/* $Id: MemeExample.java,v 1.1 1999/11/06 19:50:58 borg Exp $ */
/* The example is part of the public domain. */
package com.imaginary.example;

import com.imaginary.meme.Meme;
import java.util.Locale;

/**
 * This class creates a meme and then shows how that meme is displayed
 * for different users.
 */
public class MemeExample {
    static public void main(String[] args) {
        Meme red = new Meme("RED", "red");

        red.addTranslation(Locale.FRENCH, "rouge");
        red.addTranslation(Locale.GERMAN, "rot");
        red.addTranslation(Locale.ITALIAN, "rosso");
        red.addTranslation(new Locale("es", "EN"), "rojo");
        red.addTranslation(new Locale("ru", "RU"),
                           "\u043A\u0440\u0430\u0441\u043D\u0440\u044F");
        System.out.println("In your locale: " +
                           red.getTranslation(Locale.getDefault()));
        System.out.println("In the UK: " +
                           red.getTranslation(Locale.UK));
        System.out.println("In the US: " +
                           red.getTranslation(Locale.US));
        System.out.println("In Germany: " +
                           red.getTranslation(Locale.GERMANY));
        System.out.println("In France: " +
                           red.getTranslation(Locale.FRANCE));
        System.out.println("In Quebec: " +
                           red.getTranslation(Locale.CANADA_FRENCH));
        System.out.println("In Italy: " +
                           red.getTranslation(Locale.ITALY));
        System.out.println("In Mexico: " +
                           red.getTranslation(new Locale("es", "MX")));
        System.out.println("Don't be surprised if you cannot read this...");
        System.out.println("In Russia: " +
                           red.getTranslation(new Locale("ru", "RU")));
        System.out.println("In Sweden: " +
                           red.getTranslation(new Locale("se", "SE")));
    }
}
