import java.io.*;
import java.util.*;
import sguide.SmartGuideExit;
import sguide.XVariableSet;
import sguide.XVariableInterface;
import sguide.SGFunctions;

public class updateProperties implements SmartGuideExit
{
  public static final String COPYRIGHT = "(C) Copyright IBM Corp. 1998.  All rights reserved.";

  public static final String LONG_COPYRIGHT =
                      "Licensed Materials - Property of IBM" +
                      "\nIBM XML Enabler" +
                      "\n(C) Copyright IBM Corp. 1998.  All rights reserved." +
                      "\n\nUS Government Users Restricted Rights - Use, duplication, or" +
                      "\ndisclosure restricted by GSA ADP Schedule Contract with IBM Corp.";

  public String go(XVariableSet variables,
                   Hashtable objects,
                   String arguments)
  {
    Properties prop = null;

    try
    {
      XVariableInterface xvi = variables.lookup("default");
      File valueFile = new File("xmlEnabler.txt");
      FileWriter writer = new FileWriter(valueFile);

      writer.write("Default=" + xvi.value() + "\n");

      xvi = variables.variableWithKey("mappings");

      int numRows = SGFunctions.strToInt(xvi.value("height"));

      String orderString = "Order=";
      for (int row = 0; row < numRows; row++)
      {
        writer.write(xvi.value("[" + row + ",0]") + "=" +
                     xvi.value("[" + row + ",1]") + "\n");
        orderString += xvi.value("[" + row + ",0]") + "/";
      }

      writer.write(orderString + "\n");
      writer.close();
    }
    catch (IOException ioe) { }
    
    return "";
  }
}

