import java.io.*;
import java.net.*;
import java.util.*;


import javax.servlet.Servlet;
import javax.servlet.ServletException;
import javax.servlet.ServletOutputStream;
import javax.servlet.ServletContext;
import javax.servlet.ServletConfig;
 
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpUtils;
 
import java.lang.*;


  /* The big idea is as follows:
     module creates a server socket and sends its port number here (p)
     (message with format PUTX, where X is the port number)
     then the controls connect with message GET which is responded to by
     sending the value of p (converted to a a string).
     Now, it may happen that the controls connects before the module,
     therefore p is initialised to 0, and reset to 0 as soon as it is sent.
     This way p=0 unless the module deposited a new port number.
     Controls is supposed to keep trying till p != 0, therefore connection
     is implemented as a separate thread.
     This servr is implemented as a separate thread in order not to block
     WebEdit.
     In the future, this server should be implemented as a servlet
     */


public class SVL extends HttpServlet 
{
  public final static int DEFAULT_PORT=5500;
  protected int port=0;
  protected ServerSocket listen_socket;
  public static Integer p = new Integer(0);
  Thread socketThread;
  String hostName;
  int    portNumber;
  int counter=0;



  public void init(ServletConfig Params) throws ServletException
  {
    //Erol
    //    swingservlet = new SwingServlet();
    //Erol

    int port=0;
        
    //System.out.println("Module Manager accessed");
    try {
          super.init(Params);
    } catch (ServletException e)
      {  System.out.println(" Exception in init() of MM ");
         e.printStackTrace();
      }
 
    String portString = Params.getInitParameter("Port");
    if (portString != null)
       port = Integer.parseInt(portString);
    
    //-----
    if(port==0) port = DEFAULT_PORT;
    this.port=port;
    try { listen_socket = new ServerSocket(port);}
    catch (IOException e) {fail(e,"Exception creating server socket");}

    //Erol
    //    listen_socket.setSoTimeout(1);
    //Erol

    //System.out.println("Server: listening on port " + port);
    //-----

    // finally, branch new thread, set it up as a deamon (to terminate
    // upon completion of master program), and start it up
    //    socketThread = new Thread(this);
    //    socketThread.setDaemon(true);
    // socketThread.start();
  
    portNumber = port;
    try{
      InetAddress local = java.net.InetAddress.getLocalHost();
      hostName = local.getHostName();
    }catch(UnknownHostException e)
    {  hostName = "0";
       //System.out.println(" UnknownHostException in init() of MM ");
       e.printStackTrace();
    }
  }
 
  
  public static void fail(Exception e, String msg) {
    System.err.println(msg+":"+e);
    System.exit(1);
  }

/**
     * Write survey results to output file in response to the POSTed
     * form.  Write a "thank you" to the client.     
     */
    public void doPost(HttpServletRequest req, HttpServletResponse res)
        throws ServletException, IOException
    {
        // first, set the "content type" header of the response
        res.setContentType("text/html");

        //Get the response's PrintWriter to return text to the client.
        PrintWriter toClient = res.getWriter();
	String resultsDir="resultsdir";
	
        try {
            //Open the file for writing the survey results.
            String surveyName = req.getParameterValues("survey")[0];
            FileWriter resultsFile = new FileWriter(resultsDir
                + System.getProperty("file.separator")
                + surveyName + ".txt", true);
            PrintWriter toFile = new PrintWriter(resultsFile);

            // Get client's form data & store it in the file
            toFile.println("<BEGIN>");
            Enumeration values = req.getParameterNames();
            while(values.hasMoreElements()) {
                String name = (String)values.nextElement();
                String value = req.getParameterValues(name)[0];
                if(name.compareTo("submit") != 0) {
                    toFile.println(name + ": " + value);
                }
            }
            toFile.println("<END>");

            //Close the file.
            resultsFile.close();

            // Respond to client with a thank you
            toClient.println("<html>");
            toClient.println("<title>Thank you!</title>");
            toClient.println("Thank you for participating");
            toClient.println("</html>");

        } catch(IOException e) {
            e.printStackTrace();
            toClient.println(
                "A problem occured while recording your answers.  "
                + "Please try again.");
        }

        // Close the writer; the response is done.
        toClient.close();
    }


/**
 * This is a simple example of an HTTP Servlet.  It responds to the GET
 * and HEAD methods of the HTTP protocol.
 */
    public void doGet(HttpServletRequest req, HttpServletResponse res)
        throws ServletException, IOException
    {
      String ss=req.getPathInfo();
      
        // set header field first
        res.setContentType("text/html");

        // then get the writer and write the response data
        //PrintWriter out = res.getWriter();

	ServletOutputStream out = res.getOutputStream();

        out.println("<HEAD><TITLE> SimpleServlet Output</TITLE></HEAD><BODY>");
        out.println("<h1> SimpleServlet Output </h1>");
        out.println("<P>This is output is from SimpleServlet.");
        out.println(ss+ "ss </BODY>");
        out.close();
    }

    public String getServletInfo() {
        return "A simple servlet";
    }


  
}




