package gs.admin;

import java.util.Hashtable;

import java.io.IOException;

import javax.servlet.Servlet;
import javax.servlet.ServletException;
import javax.servlet.ServletOutputStream;
import javax.servlet.ServletContext;
import javax.servlet.ServletConfig;

import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpUtils;


import gs.db.update;
import gs.db.dbCourse;
import gs.db.dbQuestion;
import gs.db.dbSurvey;
import gs.db.dbCustomizedGrade;


import java.sql.ResultSet;

import gs.html.Html;
import gs.html.Parser;
import gs.html.RecordParser;


/**
 */
public class gCourses extends HttpServlet {

    /**
     * Service the request.
     *
     * @exception  ServletException if there is any sort of Exception
     *
     */

  public static gSystem  sys=new gSystem();

  //||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||//
  // doPost  doGet
  //||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||//  
  public void doPost  (HttpServletRequest req,HttpServletResponse response) 
       throws IOException, ServletException 
  {
    processInOut( req,response);
  }

  public void doGet(HttpServletRequest req, HttpServletResponse response)
       throws IOException, ServletException
  {
    processInOut( req,response);
  }

  //||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||//
  // processInOut
  //||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||//  

  public void processInOut (HttpServletRequest req,HttpServletResponse response)
       throws IOException, ServletException
  {

    response.setStatus(HttpServletResponse.SC_OK); 
    response.setContentType("text/html");
    
    ServletOutputStream out = response.getOutputStream();
    String templateFile = req.getPathTranslated();
    String unum    = req.getParameter("unum"); 
    String command = req.getParameter("comm"); 

    try {
      if (command == null ) 
	return;
      else if (command.equals("COURSESELECT")) {
	String next=req.getParameter("next");
	String nextcomm=req.getParameter("nextcomm");
	String cinfo=req.getParameter("cinfo");
	if (next==null) next="";
	if (nextcomm==null) nextcomm="";
	selectionPage(out, unum, req.getPathTranslated(),next ,nextcomm,cinfo );
	return;
      }
      else if(command.indexOf("STUDENT")>=0)
	selectionPage(out, unum, req.getPathTranslated(), "gs.admin.gStudents/HtdocsGrdSys/students/student.html","BEFORELOGIN","Access Student Records");

    String course  = req.getParameter("course");
    String term    = req.getParameter("term");
    String year    = req.getParameter("year");
    String title   =  req.getParameter("title");



      if (title==null) {
	if (course==null)
	  throw new Exception("State lost: Unknown course!.");
	title=course+term+year;
      }
      if (command.indexOf("BROWSE")>=0)
	browseCourse(out, unum, req.getPathTranslated(), title);

      else if(command.indexOf("NEW COURSE")>=0)
	newCourseForm(out, unum, req.getPathTranslated());

      else if(command.equals("INFO"))
	infoPage(out, unum, req.getPathTranslated());

      else if(command.indexOf("EDIT")>=0 ) 
	editCourseForm(out, unum, req.getPathTranslated(),     title);


      else if(command.indexOf("REMOVE")>=0  )
	deleteCourse(out, unum, req.getPathTranslated(),
		  title, 
		   (String)(req.getParameter("answer")));

      else if(command.indexOf("UPDATE COURSE")>=0 ) 
	updateCourse(out, unum, readCourseFields(req), req.getPathTranslated());


      else if(command.indexOf("ADD COURSE")>=0) 
	addCourse(out, unum, readCourseFields(req), req.getPathTranslated());
 
      //......................GRADES......................
      else if(command.equals("GRDCUSTOMIZEFORM"))
	gradeCustomizeForm(out, unum, req.getPathTranslated(),title);

      else if(command.indexOf("ADD(overwrite) GRADE")>=0) 
	addGrade(out, unum, req.getPathTranslated(),title,(String)(req.getParameter("grade")),(String)(req.getParameter("points")));
      else if(command.indexOf("DELETE GRADE")>=0) 
	deleteGrade(out, unum, req.getPathTranslated(),title,(String)(req.getParameter("oldgrade")));
     //_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
      //questinaire====questinaire====questinaire====questinaire====
     //_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/


      //......................QUESTIONS......................

      else if(command.indexOf("QUESTIONS")>=0)
	QuestionsForm(out, unum, req.getPathTranslated());

      else if(command.indexOf("ADD(overwrite) question")>=0)
	addQuestion(out, unum, req.getPathTranslated(),
		    (String)(req.getParameter("qn")),
		    (String)(req.getParameter("question")),
		    (String)(req.getParameter("catg")));

      else if(command.indexOf("DELETE selected questions")>=0)
	deleteQuestions(out, unum, req.getPathTranslated(),(String)(req.getParameter("list")));

      //......................SURVEY......................

      else if(command.indexOf("QUESTIONNAIRE")>=0)
	surveyMenu(out, unum, req.getPathTranslated(),title);

      else if(command.indexOf("NEW SURVEY")>=0)
	newSurveyForm(out, unum, req.getPathTranslated(), title);
	
      else if(command.indexOf("PUBLIC'S VIEW")>=0)
	browseSurvey(out, unum, req.getPathTranslated(), title, req.getParameter("surveyname"));
      else if(command.indexOf("UPDATE SURVEY")>=0)
	updateSurveyForm(out, unum, req.getPathTranslated(), title, req.getParameter("surveyname"));
      else if(command.indexOf("ADD-OVERWRITE SURVEY")>=0)
	addSurvey(out, unum, req.getPathTranslated(), title, req.getParameter("surveyname"), req.getParameter("list"));
      else if(command.indexOf("DELETE SURVEY")>=0)
	deleteSurvey(out, unum, req.getPathTranslated(), title, req.getParameter("surveyname"));




    } catch (Exception e) {
      sys.error(out,e);
      //e.printStackTrace();
      //sys.error(out,e.getMessage());
    }

    //    out.println( Html.footer() );
    out.close();
  
  }


  //--------------------------------------------------------------------//
  //Reads Course fields from the html request form
  //--------------------------------------------------------------------//
  public dbCourse readCourseFields(HttpServletRequest req) throws Exception {

    dbCourse u=new dbCourse();

    String course  = req.getParameter("course");
    String term    = req.getParameter("term");
    String year    = req.getParameter("year");
    String title   = course+term+year;

      
    if(course.equals("") ) 
      throw new Exception("Please fill the course name!");
    else if (year.equals("") ) 
      throw new Exception("Please enter the year!");
    else {
      u.fields.put("title"     , title);    
      u.fields.put("name"     ,course );
      u.fields.put("term"     , term);
      u.fields.put("year"     , year);
      u.fields.put("instructor" , req.getParameter("instructor").replace('\'','`'));
      u.fields.put("insurl" , req.getParameter("insurl").replace('\n','\0'));
      u.fields.put("insemail" , req.getParameter("insemail"));
      u.fields.put("coinstructor" , req.getParameter("coinstructor").replace('\'','`'));
      u.fields.put("coinsurl" , req.getParameter("coinsurl").replace('\n','\0'));
      u.fields.put("coinsemail" , req.getParameter("coinsemail"));
      u.fields.put("ta" , req.getParameter("ta").replace('\'','`'));
      u.fields.put("taurl" , req.getParameter("taurl").replace('\n','\0'));
      u.fields.put("taemail" , req.getParameter("taemail"));
      u.fields.put("team" , req.getParameter("team").replace('\'','`'));
      u.fields.put("url" , req.getParameter("url").replace('\n','\0'));
      u.fields.put("logourl" , req.getParameter("logourl").replace('\n','\0'));
      u.fields.put("grdtype" , req.getParameter("grdtype").replace('\'','`'));
      u.fields.put("oldtitle"  , req.getParameter("oldtitle"));
      u.fields.put("extracredits" , req.getParameter("extracredits"));
      u.fields.put("publishavg" ,req.getParameter("publishavg") );
      u.fields.put("publishfgrd"  , req.getParameter("publishfgrd"));
      u.fields.put("notes" , req.getParameter("comments").replace('\'','`'));
      
    }
    u.setIdentification();

    return u;

  }
  //--------------------------------------------------------------------//
  // findRestrictedList
  //--------------------------------------------------------------------//  
  public String findRestrictedList(String acl){
    return "<OPTION>me";
  }



  //--------------------------------------------------------------------//
  //
  //--------------------------------------------------------------------//  
  //--------------------------------------------------------------------//
  //returnMainPage(
  //--------------------------------------------------------------------//  
  public static void selectionPage(ServletOutputStream out, String unum, String templateFile,String next,String nextcomm,String cinfo)
       throws Exception, IOException 
  {
       Hashtable ht = new Hashtable();
      sys.globalValues(ht,unum);
      ht.put("next",next);
      ht.put("nextcomm",nextcomm);
      ht.put("cinfo",cinfo);
      dbCourse dbc=new dbCourse();

      Parser.parseHtml(templateFile,ht , out, new RecordParser(dbc.listCourses(),"name","course")) ;
      
  }

   

  //--------------------------------------------------------------------//
  // List ALL courses 
  //--------------------------------------------------------------------//  
  void list(ServletOutputStream out, String unum, String templateFile, boolean allFields)
       throws Exception, IOException 
  {
      Hashtable ht = new Hashtable();
      sys.globalValues(ht,unum);

      String fieldNames = "title,firstname,midname,lastname,url";
      String queryProjection = fieldNames;
      dbCourse u = new dbCourse();

      if(allFields) 	{
	fieldNames = u.getFieldNames();
	queryProjection = "*";
      }
      ResultSet rs = u.records(queryProjection,"","lastname,firstname");
      Parser.parseHtml(templateFile, ht, out,  new RecordParser(rs, fieldNames));
  }

  //--------------------------------------------------------------------//
  // Browse a course
  //--------------------------------------------------------------------//  
  void browseCourse (ServletOutputStream out, String unum, String templateDir, String title) 
       throws Exception, IOException
  {
      try {

	Hashtable ht=sys.crs_cache.get(title).getFields();
	sys.globalValues(ht,unum);
	Parser.parseHtml(templateDir+"browse.html",ht , out);
      } catch(Exception e) {
	throw new Exception("<h2>ERROR at browsing course "+title+": "+e.getMessage()+"</h2>");
      }

  }

  //--------------------------------------------------------------------//
  // open new course page using frames
  //--------------------------------------------------------------------//  
  void newCourseForm  (ServletOutputStream out, String unum, String templateDir)
       throws  Exception, IOException
  {
      Hashtable ht= new Hashtable();
      sys.globalValues(ht,unum);
      Parser.parseHtml(templateDir+"new.html", ht, out);
  }

  //--------------------------------------------------------------------//
  // open new course record form in a frame 
  //--------------------------------------------------------------------//  
  /* void newCourseRecord(ServletOutputStream out, String unum, String templateFile) 
       throws Exception, IOException
  {
      Hashtable ht = dbCourse.getEmptyFields();
      sys.globalValues(ht,unum);
      String rcl=findRestrictedList("");
      ht.put("rcl",rcl);
      Parser.parseHtml(templateFile, ht, out);
  }
  */
  //--------------------------------------------------------------------//
  // open the page to  edit an existing course
  //--------------------------------------------------------------------//  
  void editCourseForm (ServletOutputStream out, String unum, 
		      String templateDir, String title)        
       throws Exception,IOException
  {
    Hashtable ht=sys.crs_cache.get(title).getFields();
    sys.globalValues(ht,unum);
    Parser.parseHtml(templateDir+"update.html", ht, out);
  }
  //--------------------------------------------------------------------//
  //  editCourseRecord page
  //--------------------------------------------------------------------//  
  void editCourseRecord (ServletOutputStream out, String unum, 
		       String templateFile, String title)        
       throws  Exception, IOException
  {
    //Hashtable ht=dbCourse.getFields(title);
    Hashtable ht=sys.crs_cache.get(title).getFields();
      sys.globalValues(ht,unum);
      String rcl=findRestrictedList((String)ht.get("ACL"));
      ht.put("rcl",rcl);
      Parser.parseHtml(templateFile, ht, out);
  }

  //--------------------------------------------------------------------//
  // DELETE a course
  //--------------------------------------------------------------------//  
  void deleteCourse (ServletOutputStream out, String unum,
		   String templateDir, String title, String answer) 
       throws Exception, IOException
  {
    String templateFile=templateDir;
    Hashtable ht = new Hashtable();
    sys.globalValues(ht,unum);
    
      if(answer == null) {
	templateFile=templateFile+"confirm.html";
	ht.put("message", "<br>Do you really want to delete the course <i>"+title+"</i>?");
	ht.put("actionurl", "updatemessage.html");
	ht.put("comm","REMOVE");	
	ht.put("title",title);
      } 
      else if(answer.equals("YES")) {
	//dbCourse.delete(title);
	sys.crs_cache.delete(title);
	ht.put("message", "Course information has been succesfully deleted!");
      }
      else if(answer.equals("NO")) {
	out.println("<script language=JavaScript> history.go(-2);</script>");
      }
      Parser.parseHtml(templateFile, ht, out);
      
  }

  //--------------------------------------------------------------------//
  // add new Course
  //--------------------------------------------------------------------//  
  void addCourse(ServletOutputStream out, String unum, dbCourse dbc, String templateDir )
       throws Exception,IOException
  {
    try {
      //dbc.add();
      sys.crs_cache.add(dbc);

	Hashtable ht=sys.crs_cache.get(dbc.title).getFields();
	sys.globalValues(ht,unum);
	Parser.parseHtml(templateDir+"browse.html", ht, out);
	
    } catch( Exception e ) {
      String error =e.getMessage();
      if (error.indexOf("unique") >=0) {
	error= new String("This course title id exists in the system. <br> Please try another one.");
	}
      throw new Exception(error);
    }    
  }
  //--------------------------------------------------------------------//
  // update course record 
  //--------------------------------------------------------------------//  

  void updateCourse(ServletOutputStream out, String unum, dbCourse dbc,String templateDir)
       throws Exception,IOException
    {
      try {
	//	dbc.update();
	sys.crs_cache.update(dbc);
	Hashtable ht=sys.crs_cache.get(dbc.title).getFields();
	sys.globalValues(ht,unum);
	Parser.parseHtml(templateDir+"browse.html", ht, out);
	
      } catch( Exception e ) {
	out.println( Html.header("Course Records") );
	String error =e.getMessage();
	if (error.indexOf("unique") >=0) {
	  error= new String("This course title id exists in the system. <br> Please try another one.");
	}
	throw new Exception(error);
      }   
    }
  //--------------------------------------------------------------------//
  // 
  //--------------------------------------------------------------------//  
  //--------------------------------------------------------------------//
  // info page
  //--------------------------------------------------------------------//  
  void infoPage(ServletOutputStream out, String unum,String templateFile) 
       throws Exception,IOException
  {
      Hashtable ht = new Hashtable();
      sys.globalValues(ht,unum);
      Parser.parseHtml(templateFile,ht,out);
  }

  //_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
  //---------------------------------GRADES--------------------------------
  //_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
  //--------------------------------------------------------------------//
  // GRADES:listgrades
  //--------------------------------------------------------------------//  
  ResultSet listGrades(String title )
       throws Exception, IOException 
  {
      dbCustomizedGrade q=new dbCustomizedGrade();
      String fieldNames = q.getFieldNames();
      String queryProjection = "*";
      return  q.records(queryProjection,"course='"+title+"'","points");
  }

   //--------------------------------------------------------------------//
  //GRADES:gradeCusomizeForm
  //--------------------------------------------------------------------//  
  void gradeCustomizeForm(ServletOutputStream out, String unum,String templateFile,String title) 
       throws Exception,IOException
  {
      Hashtable ht = new Hashtable();
      sys.globalValues(ht,unum);
      ht.put("title",title);
      Parser.parseHtml(templateFile, ht, out,  new RecordParser(listGrades(title), dbCustomizedGrade.fieldnames));
  }
 
  //--------------------------------------------------------------------//
  //GRADES:addGrade
  //--------------------------------------------------------------------//  
  void addGrade(ServletOutputStream out, String unum,String templateFile,String title,String grade,String points) 
       throws Exception,IOException
  {
    //System.out.println("grde points"+grade+points);
    //System.out.println("grde points"+grade+points);

    dbCustomizedGrade g=new dbCustomizedGrade();
    g.makeGrade(title,grade,points);
    gradeCustomizeForm(out, unum, templateFile,title);

  }

    //--------------------------------------------------------------------//
    //GRADES:deleteGrade
    //--------------------------------------------------------------------//  
    void deleteGrade(ServletOutputStream out, String unum,String templateFile,String title,String grade) 
    throws Exception,IOException
    {
      dbCustomizedGrade g=new dbCustomizedGrade();
      g.removeGrade(title,grade);
    gradeCustomizeForm(out, unum, templateFile,title);

  }
  //_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
  //--------------------------_ GRADES--END -------------------------
  //_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/



  //_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
  //---------------------------------QUESTIONS---------------------------
  //_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/


  //--------------------------------------------------------------------//
  // QUESTION: listQuestions( )
  //--------------------------------------------------------------------//  
  ResultSet listQuestions( )
       throws Exception, IOException 
  {
      dbQuestion q=new dbQuestion();
      String fieldNames = q.getFieldNames();
      String queryProjection = "*";
      return  q.records(queryProjection,"","category,qid");
  }
  //--------------------------------------------------------------------//
  // QUESTION:
  //--------------------------------------------------------------------//  
  void QuestionsForm(ServletOutputStream out, String unum, String templateFile)
       throws Exception, IOException 
  {
      Hashtable ht = new Hashtable();
      sys.globalValues(ht,unum);
      ht.put("newqid",Integer.toString(new dbQuestion().findMaxQN()+1));

      Parser.parseHtml(templateFile, ht, out,  new RecordParser(listQuestions(), dbQuestion.fieldnames));
  }
  //--------------------------------------------------------------------//
  // QUESTION:
  //--------------------------------------------------------------------//  
  void deleteQuestions(ServletOutputStream out, String unum, String templateFile, String list) 
        throws Exception, IOException 
  {
    dbQuestion.deleteList(list);
    QuestionsForm(out, unum, templateFile);
  }

  //--------------------------------------------------------------------//
  // QUESTION:
  //--------------------------------------------------------------------//  
 void addQuestion(ServletOutputStream out, String unum, String templateFile,
		   String qn,String question ,String catg) 
        throws Exception, IOException 
  {
    dbQuestion q=new dbQuestion(qn,question,catg);
    q.add();
    QuestionsForm(out, unum, templateFile);
  }
  /*
  void updateQuestions(ServletOutputStream out, String unum, String templateFile,  String qn,String question ,String catg) 
        throws Exception, IOException 
  {
    dbQuestion q=new dbQuestion(qn,question,catg);
    q.add();
    QuestionsForm(out, unum, templateFile);
  }
  */


  //_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
  //--------------------------_ QUESTIONS--END -------------------------

  //_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
  //---------------------------------SURVEY--------------------------------
  //_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/


  //--------------------------------------------------------------------//
  // SURVEY:
  //--------------------------------------------------------------------//  

  void surveyMenu(ServletOutputStream out, String unum, String templateDir,String title)
       throws Exception, IOException 
  {
      Hashtable ht = new Hashtable();
      sys.globalValues(ht,unum);
      ht.put("title",title);
      dbSurvey s=new dbSurvey();
      String fieldNames = "surveyname";
      String queryProjection = "DISTINCT surveyname";
      ResultSet rs = s.records(queryProjection,"course='"+title+"'","");

      
      Parser.parseHtml(templateDir+"surveys/surveyMenu.html",ht , out, new RecordParser(rs, fieldNames));
  }

  //--------------------------------------------------------------------//
  // SURVEY:
  //--------------------------------------------------------------------//  

  void updateSurveyForm(ServletOutputStream out, String unum, String templateDir,String course,String surveyname)
       throws Exception, IOException 
  {
      Hashtable ht = new Hashtable();
      sys.globalValues(ht,unum);
      ht.put("title",course);
      if (surveyname==null) 
	throw new Exception("Please select an existing  survey first!");
      ht.put("surveyname",surveyname);
      dbSurvey s=new dbSurvey();
      ht.put("currentlist",s.currentQuestionList(course,surveyname));
      Parser.parseHtml(templateDir+"surveyForm.html", ht, out,  new RecordParser(listQuestions(), dbQuestion.fieldnames)    );

  }
  //--------------------------------------------------------------------//
  // SURVEY:
  //--------------------------------------------------------------------//  
  void newSurveyForm(ServletOutputStream out, String unum, String templateDir,String course)
       throws Exception, IOException 
  {
      Hashtable ht = new Hashtable();
      sys.globalValues(ht,unum);
      ht.put("title",course);
      ht.put("surveyname","");

      Parser.parseHtml(templateDir+"surveyForm.html", ht, out,  new RecordParser(listQuestions(), dbQuestion.fieldnames));
  }
  //--------------------------------------------------------------------//
  // SURVEY:
  //--------------------------------------------------------------------//  
  void addSurvey(ServletOutputStream out, String unum, String templateFile,String course,String surveyname, String list)
       throws Exception, IOException 
  {
    if (surveyname==null) 
      throw new Exception("Please enter the survey name first!");
      Hashtable ht = new Hashtable();
      sys.globalValues(ht,unum);
      ht.put("surveyname",surveyname);
      ht.put("course",course);


      dbSurvey s=new dbSurvey();
      s.makeSurvey(course,surveyname,list);
      
    Parser.parseHtml(templateFile, ht, out,  new RecordParser(s.surveyQuestions(course,surveyname),s.surveyQuestionsFields(course,surveyname)    ));
  }
  //--------------------------------------------------------------------//
  // SURVEY:
  //--------------------------------------------------------------------//  
  void browseSurvey(ServletOutputStream out, String unum, String templateDir,String course,String surveyname)
       throws Exception, IOException 
  {
    if (surveyname==null) 
      throw new Exception("Please select the survey name first!");
    Hashtable ht = new Hashtable();
    sys.globalValues(ht,unum);
    ht.put("surveyname",surveyname);
    ht.put("course",course);


    dbSurvey s=new dbSurvey();
    Parser.parseHtml(templateDir+"browse.html", ht, out,  new RecordParser(s.surveyQuestions(course,surveyname),s.surveyQuestionsFields(course,surveyname)    ));
  }
  //--------------------------------------------------------------------//
  // SURVEY:
  //--------------------------------------------------------------------//  
  void deleteSurvey(ServletOutputStream out, String unum, String templateDir,String course,String surveyname)
       throws Exception, IOException 
  {
      Hashtable ht = new Hashtable();
      sys.globalValues(ht,unum);
      if (surveyname==null) 
	throw new Exception("Please select an existing  survey first!");

      ht.put("surveyname",surveyname);
      ht.put("title",course);

      dbSurvey s=new dbSurvey();
      s.removeSurvey(course,surveyname);
      
      Parser.parseHtml(templateDir+"deleted.html", ht, out );
  }
  //_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
  //---------------------------------SURVEY-END------------------------------
  //_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/


} //class close


