package gs.admin;
import java.io.*;

import gs.conf.Configuration;
import java.util.Hashtable;

import java.io.IOException;
import javax.servlet.ServletException;

import javax.servlet.ServletOutputStream;
import java.util.Date;
import gs.db.U;
import gs.db.dbUser;
import gs.db.database;

import gs.html.Html;
import gs.html.Parser;
import gs.html.RecordParser;

import gs.cache.UserCache;
import gs.cache.CourseCache;
import gs.cache.StudentCache;
import gs.cache.AssignmentCache;
//XML
import com.ibm.xml.parser.*;
import org.w3c.dom.*;
import com.lotus.xsl.*;
import com.lotus.xsl.xml4j.*;
import com.ibm.xml.parsers.*;
import gs.xml.xXML;

//XML-end
public class gSystem {
  public static String host="http://class-server.npac.syr.edu:5757";
  public static String home="http://class-server.npac.syr.edu:5757/HtdocsGrdSys/";
  public static String localdir="/home/B10E/msen7/oserver/";
  public static String images="http://class-server.npac.syr.edu:5757/HtdocsGrdSys/images";
  public static String htdocs="HtdocsGrdSys/";
  public static String help="report/manuals/";

  public static String cgi="http://class-server.npac.syr.edu:5757/DB";
  
  public static String admin="admin/";
  public static String servlet="GS";

  public static String htpasswd="";  
  public static String pwdfile="";  

  public static String style ="<link rel='stylesheet' type='text/css' href='/Grading/styles.css'>";
  public static String bgcolor="white";  
  public static String background="none.gif";  

  public static boolean DONTASKPWD=false;

  public static UserCache usr_cache;
  public static CourseCache crs_cache;
  public static StudentCache std_cache;
  public static AssignmentCache asgn_cache;

  public static int acclcount=0;
  public static PrintWriter errl=null;
  public static PrintWriter accl=null;
  public static boolean ErrorLog=false;
  public static String ELogFile="/home/B10E/msen7/oserver/GrdSys/servlets/gs/log/error_log.dat";
  public static boolean AccessLog=false;
  public static String AccessLogFile="/home/B10E/msen7/oserver/GrdSys/servlets/gs/log/access_log.dat";
  public static Document tree;
  public static Element root;
  public static xXML xml = new xXML();
  public static XSLProcessor p ;
  public static String resultns;  
  public static Document emptydoc;

  public gSystem ()
  { 
    Configuration c=new Configuration();
    Configuration.loadConfiguration();
    constructGlobalTree();
    initializeXML();
  }
 
  public static void     initializeXML() {
    ProcessXSL xmlProcessorLiason = new ProcessXSL(); 
    xmlProcessorLiason.m_use_validation = false;
    p = new XSLProcessor(xmlProcessorLiason);
    resultns = new String("DEBUG");  
  }

  public static void globalValues(Hashtable ht,String unum){
    ht.put("host",host);
    ht.put("help",help);
    ht.put("cgi",cgi);
    ht.put("servlet",servlet);
    ht.put("images",images );
    ht.put("style",style);
    ht.put("bgcolor",bgcolor);
    ht.put("background",  background);   
    ht.put("unum",unum);
  }
  public static void constructGlobalTree() {
    try {
    Document tree=xml.giveMeEmptyDocument(); 
    root=xml.makeMeRoot(tree,"global"); 
    xml.addMyTextNode(tree,root,"host"   ,host);
    xml.addMyTextNode(tree,root,"help",help);
    xml.addMyTextNode(tree,root,"cgi",cgi);
    xml.addMyTextNode(tree,root,"servlet",servlet);
    xml.addMyTextNode(tree,root,"images",images );
    xml.addMyTextNode(tree,root,"style",style);
    xml.addMyTextNode(tree,root,"bgcolor",bgcolor);
    xml.addMyTextNode(tree,root,"background",  background);   
    }catch (Exception e){
      System.out.println(";;;;;;");
    }
  }

  public static void addGlobalTree(Document d) throws Exception{
    Element droot=d.getDocumentElement() ;
    // Element croot=(Element)root.cloneNode(true);
    droot.appendChild(root);
    // xml.addMyTextNode(d,root,"unum",unum);
  }
  public static void addUserTree(Document d, String unum) throws Exception{
    Element droot=d.getDocumentElement() ;
    // Element croot=(Element)root.cloneNode(true);
    // root.appendChild(root);
    Element user= xml.addMyNode(d,droot,"user");
    xml.addMyTextNode(d,user,"unum",unum);
  }
  public static void addFunction(Document d, String f) throws Exception{
    Element droot=d.getDocumentElement() ;
    xml.addMyTextNode(d,droot,"function",f);
  }

  public static void clearMemory ()
  { 
    usr_cache.clear();
    crs_cache.clear();
    std_cache.clear();
    asgn_cache.clear();
    database.closeAll();
  }
  protected void finalize(){
    if (errl!=null) errl.flush(); 
    if (accl!=null) accl.flush();
  }
 
  //~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
  // ERROR ERROR ERROR ERROR ERROR ERROR ERROR ERROR ERROR ERROR ERROR ERROR ERROR 
  //~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
  public static void error (ServletOutputStream err,String message) throws IOException, ServletException {
    try {
     
      Hashtable ht = new Hashtable();
      if (message==null)message="--NULL-MESSAGE--";
      ht.put("error",message);
      globalValues(ht,"");
      String templateFile=localdir+htdocs+admin+"error.html";
      
      Parser.parseHtml(templateFile, ht, err);
    } catch( Exception e ) {
      // e.printStackTrace();
      err.println("<h2>ERROR : "+e.getMessage()+" while printing error page</h2> <font face=helvetica color=red> Please report to <a href=\"mailto:msen7@npac.syr.edu\">msen7@npac.syr.edu</a>.<br></font>");
      
    }
  }
  public static void error (ServletOutputStream err,Exception e) throws IOException, ServletException {
    
    try { error(err,e.getMessage());} catch (Exception any) {}
    if ( !ErrorLog ) return;
    e.printStackTrace(errl);
    errl.flush();
  }
  public static void openErrorLogFile() throws Exception, IOException  {
    try {
     errl = new PrintWriter
	(new DataOutputStream
	 (new FileOutputStream
	  ( ELogFile,true)));
     System.out.println("Error Log File opened! \n\t"+ELogFile);
     ErrorLog=true;
    } catch (IOException e) {
      ErrorLog=false;
      String em="Error Log File not opened properly, check your path please. <br>\n"+e.getMessage();
      System.out.println(em);
      throw new Exception(em);
      //System.exit(1);
    }
  }
  public static void closeErrorLogFile() throws Exception{
    try {
     errl.close();
     ErrorLog=false;
        System.out.println("Error Log File closed!");
    } catch (Exception e) {
      System.out.println("Error Log File could not be CLOSED properly\n"+e.getMessage());
      throw e;
      //System.exit(1);
    }
  }
  //~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
  // LOG  LOG  LOG  LOG  LOG  LOG  LOG  LOG  LOG  LOG  LOG  LOG  LOG  LOG  LOG  LOG 
  //~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
  // LOG
  // LOG
  public static void  recordAccess(String unum,String course, String request) throws IOException, ServletException {
    //System.out.println(unum+course+request);
    acclcount++;
    Date d=new Date();
    String dstr= d.toString() ;
    accl.println(request+"|"+unum+"|"+course+"|"+dstr);
    if (acclcount%5==0) accl.flush();
  }
  // LOG
  public static void openAccessLogFile() throws Exception, IOException  {
    try {
     accl = new PrintWriter
	(new DataOutputStream
	 (new FileOutputStream
	  ( AccessLogFile,true)));
     System.out.println("Access Log File opened! \n\t"+AccessLogFile);
     AccessLog=true;
    } catch (IOException e) {
      AccessLog=false;
      String em="Access Log File not opened properly, check your path please. <br>\n"+e.getMessage();
      System.out.println(em);
      throw new Exception(em);
      //System.exit(1);
    }
  }
  // LOG
  public static void closeAccessLogFile() throws Exception{
    try {
     accl.close();
     AccessLog=false;
        System.out.println("Access Log File closed!");
    } catch (Exception e) {
      System.out.println("Access Log File could not be CLOSED properly\n"+e.getMessage());
      throw e;
      //System.exit(1);
    }
  } 
 //~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
  // ACCESS ACCESS ACCESS ACCESS ACCESS ACCESS ACCESS ACCESS ACCESS ACCESS ACCESS 
  //~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
  public boolean accessPermission(String unum,String course, String request)
       throws Exception 
  {
    if (request.indexOf("TAKEEXAM-OPEN") >=0 ) return true; //internal check,publushed,available,std,ins
    // System.out.println(unum+course+request);

    recordAccess(unum,course,request);
    dbUser u=usr_cache.get(unum);
    String ACL=(String) u.fields.get("ACL");
    int  PRIVILIGE=Integer.parseInt((String) u.fields.get("privilige"));
    if ( PRIVILIGE<=U.SUPER
	 || ACL.indexOf(course) >=0
	 || course.indexOf("ALL") >=0
	 || request.indexOf("COURSE_RECORDS") >=0 ) {
      //............................GRADING............................
      if (request.indexOf("GRADING_RECORDS:") >=0) {
	
	if (request.indexOf("GRMENU") >=0 )
	  { /*if (PRIVILIGE<=U.)  everybody*/return true;}
	else if (request.indexOf("Assignments listed") >=0 )
	  {/*if (PRIVILIGE<=U.) everybody*/return true;}
	else if (request.indexOf("LISTASSIGNMENTS") >=0 )
	  {/*if (PRIVILIGE<=U.) everybody*/return true;}
	else if (request.indexOf("INFO") >=0 )
	  {/*if (PRIVILIGE<=U.) everybody*/return true;}
	else if (request.indexOf("GRADEASSIGNMENT") >=0 )
	  {if (PRIVILIGE<=U.TA) return true;}
	else if (request.indexOf("UPDATE_A_GRADE") >=0 )
	  {if (PRIVILIGE<=U.TA) return true;}
	else if (request.indexOf("UPDATE_A_STUDENT") >=0 )
	  {if (PRIVILIGE<=U.TA) return true;}
	else if (request.indexOf("SHOWSTUDENTSTDVIEWGRADES") >=0 )
	  {if (PRIVILIGE<=U.TA) return true;}
	else if (request.indexOf("SHOWSTUDENTINSVIEWGRADES") >=0 )
	  {if (PRIVILIGE<=U.TA) return true;}
	else if (request.indexOf("Students listed") >=0 )
	  {/*if (PRIVILIGE<=U.)everybody*/ return true;}
	else if (request.indexOf("LISTSTUDENTS") >=0 )
	  {/*if (PRIVILIGE<=U.)everybody*/ return true;}
	else if (request.indexOf("GRADESTUDENT") >=0 )
	  {if (PRIVILIGE<=U.TA) return true;}
	else if (request.indexOf("Statistics") >=0 )
	  {/*if (PRIVILIGE<=U.) everybody*/return true;}
	else if (request.indexOf("AVERAGE_ST") >=0 )
	  {/*if (PRIVILIGE<=U.) everybody*/return true;}
	else if (request.indexOf("RANKS") >=0 )
	  {/*if (PRIVILIGE<=U.) everybody*/return true;}
	else if (request.indexOf("RECALCULATE") >=0 )
	  {/*if (PRIVILIGE<=U.) everybody*/return true;}
	else if (request.indexOf("GRADE_ST") >=0 )
	  {/*if (PRIVILIGE<=U.) everybody*/return true;}
	else if (request.indexOf("Survey") >=0 )
	  {/*if (PRIVILIGE<=U.) everybody*/return true;}
	else if (request.indexOf("LISTSURVEYS") >=0 )
	  {/*if (PRIVILIGE<=U.) everybody*/return true;}

	else if (request.indexOf("SHOWSURVEY") >=0 )
	  {/*if (PRIVILIGE<=U.TA) everybody*/ return true;}
	else if (request.indexOf("Set Options") >=0 )
	  {/*if (PRIVILIGE<=U.) everybody*/return true;}
	else if (request.indexOf("SETOPTION") >=0 )
	  {if (PRIVILIGE<=U.TA) return true;}
	 
	//System.out.println(" ! ! ! ! SECURITY CHECK ! ! ! ! request ="+request );
	
      }
    //............................QUIZZES............................
      else if (request.indexOf("QUIZZES:") >=0 ) {
	return true;
      }
      else if (request.indexOf("TAKEEXAM-USERS:") >=0 ) {
	return true;
      }
      else if (request.indexOf("QUESTIONGRADER:") >=0 ) {
	return true;
      }
      else if (request.indexOf("XQUESTIONS:") >=0 ) {
	return true;
      }
      else if (request.indexOf("XQB:") >=0 ) {
	return true;
      }
    //............................ASSIGNMENT............................
      else if (request.indexOf("ASSIGNMENT_RECORDS:") >=0 ) {
	if (request.indexOf("BROWSE") >=0 )
	  {if (PRIVILIGE<=U.BROWSER) return true;}
	else if (request.indexOf("MAIN") >=0 )
	  {if (PRIVILIGE<=U.BROWSER) return true;}
	else if (request.indexOf("LIST") >=0 )
	  {if (PRIVILIGE<=U.BROWSER) return true;}
	else if (request.indexOf("LISTALL") >=0 )
	  {if (PRIVILIGE<=U.BROWSER) return true;}
	else if (request.indexOf("SHOW") >=0 )
	  {if (PRIVILIGE<=U.TA) return true;}
	else if (request.indexOf("NEW") >=0 )
	  {if (PRIVILIGE<=U.TA) return true;}
	else if (request.indexOf("SKIP") >=0 )
	  {if (PRIVILIGE<=U.BROWSER) return true;}
	else if (request.indexOf("INFO") >=0 )
	  {if (PRIVILIGE<=U.BROWSER) return true;}
        else if (request.indexOf("CANCEL") >=0 )
	  {if (PRIVILIGE<=U.BROWSER) return true;}
	else if (request.indexOf("EDIT") >=0 )
	  {if (PRIVILIGE<=U.TA) return true;}
	else if (request.indexOf("DELETE") >=0 )
	  {if (PRIVILIGE<=U.TA) return true;}
	else if (request.indexOf("UPDATE") >=0 )
	  {if (PRIVILIGE<=U.TA) return true;}
	else if (request.indexOf("ADD") >=0 )
	  {if (PRIVILIGE<=U.TA) return true;}
	else if (request.indexOf("BEFORELOGIN") >=0 )
	  {if (PRIVILIGE<=U.BROWSER) return true;}
        else if (request.indexOf("Post Office") >=0 )
	  {if (PRIVILIGE<=U.BROWSER) return true;}
	else if (request.indexOf("Class List") >=0 )
	  {if (PRIVILIGE<=U.BROWSER) return true;}
	else if (request.indexOf("PUBLISH") >=0 )
	  {if (PRIVILIGE<=U.TA) return true;}
      }
    //............................COURSE............................
      else if (request.indexOf("COURSE_RECORDS:") >=0 ) {
	if (request.indexOf("BROWSE") >=0 )
	  {if (PRIVILIGE<=U.BROWSER) return true;}
	else if (request.indexOf("NEW COURSE") >=0 )
	  {if (PRIVILIGE<=U.INSTRUCTOR) return true;}
	else if (request.indexOf("INFO") >=0 )
	  {if (PRIVILIGE<=U.BROWSER) return true;}
	else if (request.indexOf("EDIT") >=0 )
	  {if (PRIVILIGE<=U.CO_INSTRUCTOR) return true;}
	else if (request.indexOf("REMOVE") >=0 )
	  {if (PRIVILIGE<=U.INSTRUCTOR) return true;}
	else if (request.indexOf("UPDATE COURSE") >=0 )
	  {if (PRIVILIGE<=U.CO_INSTRUCTOR) return true;}
	else if (request.indexOf("ADD COURSE") >=0 )
	  {if (PRIVILIGE<=U.INSTRUCTOR) return true;}
	else if (request.indexOf("GRDCUSTOMIZEFORM") >=0 )
	  {if (PRIVILIGE<=U.CO_INSTRUCTOR) return true;}
	else if (request.indexOf("ADD(overwrite) GRADE") >=0 )
	  {if (PRIVILIGE<=U.CO_INSTRUCTOR) return true;}
	else if (request.indexOf("DELETE GRADE") >=0 )
	  {if (PRIVILIGE<=U.CO_INSTRUCTOR) return true;}
	else if (request.indexOf("QUESTIONS") >=0 )
	  {if (PRIVILIGE<=U.BROWSER) return true;}
	else if (request.indexOf("ADD(overwrite) question") >=0 )
	  {if (PRIVILIGE<=U.CO_INSTRUCTOR) return true;}
	else if (request.indexOf("DELETE selected questions") >=0 )
	  {if (PRIVILIGE<=U.CO_INSTRUCTOR) return true;}
	else if (request.indexOf("QUESTIONNAIRE") >=0 )
	  {if (PRIVILIGE<=U.BROWSER) return true;}
	else if (request.indexOf("NEW SURVEY") >=0 )
	  {if (PRIVILIGE<=U.BROWSER) return true;}
	else if (request.indexOf("PUBLIC'S VIEW") >=0 )
	  {if (PRIVILIGE<=U.BROWSER) return true;}
	else if (request.indexOf("UPDATE SURVEY") >=0 )
	  {if (PRIVILIGE<=U.BROWSER) return true;}
	else if (request.indexOf("ADD-OVERWRITE SURVEY") >=0 )
	  {if (PRIVILIGE<=U.CO_INSTRUCTOR) return true;}
	else if (request.indexOf("DELETE SURVEY") >=0 )
	  {if (PRIVILIGE<=U.CO_INSTRUCTOR) return true;}
      }
    //............................STUDENT............................
      else if (request.indexOf("STUDENT_RECORDS:") >=0 ) {
	if (request.indexOf("BROWSE") >=0 )
	  {if (PRIVILIGE<=U.BROWSER) return true;}
	else if (request.indexOf("MAIN") >=0 )
	  {if (PRIVILIGE<=U.BROWSER) return true;}
	else if (request.indexOf("LIST") >=0 )
	  {if (PRIVILIGE<=U.BROWSER) return true;}
	else if (request.indexOf("LISTALL") >=0 )
	  {if (PRIVILIGE<=U.BROWSER) return true;}
	else if (request.indexOf("SHOW") >=0 )
	  {if (PRIVILIGE<=U.TA) return true;}
	else if (request.indexOf("NEW") >=0 )
	  {if (PRIVILIGE<=U.TA) return true;}
	else if (request.indexOf("SKIP") >=0 )
	  {if (PRIVILIGE<=U.BROWSER) return true;}
	else if (request.indexOf("INFO") >=0 )
	  {if (PRIVILIGE<=U.BROWSER) return true;}
        else if (request.indexOf("CANCEL") >=0 )
	  {if (PRIVILIGE<=U.BROWSER) return true;}
	else if (request.indexOf("EDIT") >=0 )
	  {if (PRIVILIGE<=U.TA) return true;}
	else if (request.indexOf("DELETE") >=0 )
	  {if (PRIVILIGE<=U.TA) return true;}
	else if (request.indexOf("UPDATE") >=0 )
	  {if (PRIVILIGE<=U.TA) return true;}
	else if (request.indexOf("ADD") >=0 )
	  {if (PRIVILIGE<=U.TA) return true;}
	else if (request.indexOf("BEFORELOGIN") >=0 )
	  {if (PRIVILIGE<=U.BROWSER) return true;}
        else if (request.indexOf("Post Office") >=0 )
	  {if (PRIVILIGE<=U.BROWSER) return true;}
	else if (request.indexOf("Class List") >=0 )
	  {if (PRIVILIGE<=U.BROWSER) return true;}
      }
    //----------------------------USER----------------------------
      else if (request.indexOf("USER_RECORDS:") >=0 ) {
	if (PRIVILIGE<=U.SUPER) return true;
	String comments=(String) u.fields.get("comments");
	if  (request.indexOf("MAIN") >=0 )
	  {if (comments.indexOf("distinguished User")>=0) return true; }
	else if (request.indexOf("list") >=0 )
	  {if (comments.indexOf("distinguished User")>=0) return true; }
	else if (request.indexOf("LISTALL") >=0 )
 	  {if (comments.indexOf("distinguished User")>=0) return true; }
	else if (request.indexOf("FRAME") >=0 )
	  {if (comments.indexOf("distinguished User")>=0) return true; }
        else if (request.indexOf("SHOW") >=0 )
	  {if (comments.indexOf("distinguished User")>=0) return true; }
	else if (request.indexOf("NEW") >=0 )
	  {if (comments.indexOf("distinguished User")>=0) return true; }
	else if (request.indexOf("NEWRECORD") >=0 )
	  {if (comments.indexOf("distinguished User")>=0) return true; }
	else if (request.indexOf("INFO") >=0 )
	  {if (comments.indexOf("distinguished User")>=0) return true; }
	else if (request.indexOf("CANCEL") >=0 )
	  {if (comments.indexOf("distinguished User")>=0) return true; }
	else if (request.indexOf("EDIT") >=0 )
	  {if (comments.indexOf("distinguished User")>=0) return true; }
        else if (request.indexOf("EDITRECORD") >=0 )
 	  {if (comments.indexOf("distinguished User")>=0) return true; }
	else if (request.indexOf("DELETE") >=0 )
	  {if (comments.indexOf("distinguished User")>=0) return true; } 
	else if (request.indexOf("UPDATE") >=0 )
	  {if (comments.indexOf("distinguished User")>=0) return true; }  
	else if (request.indexOf("ADD") >=0 )
	  {if (comments.indexOf("distinguished User")>=0) return true; }
      }
    //----------------------------SERVICES----------------------------
      else if (request.indexOf("SERVICE:") >=0 ) {
	if (request.indexOf("Password Assignment") >=0 )
	 {if (PRIVILIGE<=U.SYSTEM) return true;}
       else if (request.indexOf("System Services")>=0)
	 { /*if (PRIVILIGE<=U.) everybody*/ return true;}
       else if (request.indexOf("CHANGE")>=0)
	 {if (PRIVILIGE<=U.TA) return true;}
       else if (request.indexOf("Preferences")>=0)
	 {if (PRIVILIGE<=U.TA) return true;}
       else if (request.indexOf("PREFERENCES")>=0)
	 {if (PRIVILIGE<=U.SUPER) return true;}
       else if (request.indexOf("Backup") >=0 )
	 {if (PRIVILIGE<=U.SUPER) return true;}
       else if (request.indexOf("Majordomo Subscription") >=0 )
	 {if (PRIVILIGE<=U.SYSTEM) return true;}
       else if (request.indexOf("Post Office") >=0 )
	 {if (PRIVILIGE<=U.BROWSER) return true;}
       else if (request.indexOf("Class List") >=0 )
	 {if (PRIVILIGE<=U.BROWSER) return true;}
      }

    }
    throw new Exception("You do not have privileges to continue! <br>"+request+"<br>P:"+PRIVILIGE);
  }
}

