package gs.admin;

import org.w3c.dom.*;

import java.io.PrintWriter;
import java.io.IOException;

import javax.servlet.ServletException;
import javax.servlet.ServletOutputStream;

import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import gs.dbxml.dbxQB;
import gs.dbxml.dbxQuestion;
import gs.dbxml.dbxQuiz;
import gs.dbxml.dbxAnswers;

import java.util.Hashtable;
import java.util.Enumeration;
/**
 */
public class xQGrader extends xGeneric {

  /**
   * Service the request.
   *
   * @exception  ServletException if there is any sort of Exception
   *
   */
  public  xQGrader(){SERVICESTATION="QUESTIONGRADER";}
  //%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  // serveCommand
  //%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  public void  serveCommand(PrintWriter printer,String unum,String course,String command,HttpServletRequest req) throws Exception{
    //SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS
    //ASK PERMISSION above does not ask any permission
    //SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS
    // sys.accessPermission(unum,course,"xQGrader:"+command);
    //SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS
    String quizname=req.getParameter("quizname");
    if(command.equals("GRADEQUESTION")) //
      {
	dbxQuestion dxq = new dbxQuestion(course,quizname,req.getParameter("qid"));
	Document grdoc=dxq.doc;
	grade(grdoc,filterAnswers(req),false);
	parseXML(printer,unum,grdoc,"questionGRADE","");
      }
    else if(command.equals("GRADEQUESTIONFROMQB")) //
      {
	dbxQB dxq = new dbxQB(course,quizname,req.getParameter("qid"));
	Document grdoc=dxq.doc; 
	grade(grdoc,filterAnswers(req),false);
	parseXML(printer,unum,grdoc,"qbGRADE","");
      }
    else if(command.equals("LISTQUESTIONSCORES-I")) //
      {
	dbxQuestion dxq = new dbxQuestion(course,quizname);
	parseXML(printer,unum,dxq.doc,"questionSCORES-I","listQuestions");
      }
    else if(command.equals("QUIZRESULTS")) //
      {
	returnQuizResults(printer,unum,course,quizname,req);
      }
    else if(command.equals("QUESTIONRESULTS")) //
      {
	returnQuestionResults(printer,unum,course,quizname,req.getParameter("qid"),req);
      }

    else if(command.equals("LISTSTUDENTS")) //
      {
	returnStudents(printer,unum,course,quizname,req);
      }
    else if(command.equals("HANDGRADEQUESTION")) //
      {
	handGradeQn(printer,unum,req.getParameter("accesscode"),course,quizname,req.getParameter("qid"),req.getParameter("score"));
      }



  }


  public Hashtable filterAnswers(HttpServletRequest  req)throws Exception {
    Hashtable ht=new Hashtable();
    String qid=req.getParameter("qid");
    ///
    for (Enumeration e = req.getParameterNames() ; e.hasMoreElements() ;) 
      System.out.println(e.nextElement());
    ///
    String [] stdans=req.getParameterValues("ans"+qid);
    if (stdans !=null) {
      Hashtable qht= new Hashtable();
      for (int i=0;i<stdans.length;i++) {
	qht.put(stdans[i],"NaN");
	System.out.println(" ht.put(stdans[i],qid); "+stdans[i]);
      }
      ht.put(qid,qht);
    }
    return ht;
  }

  //%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  // grade from xtakeexam
  //%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  public static int grade(Document eXam,Hashtable ht, boolean allquestions) throws Exception {

    int totalscore=0;
    int totalpoints=0;

    NodeList elements = sys.xml.getElements(eXam,"course/quiz","question");      
    int elementCount = elements.getLength();
    for (int i = 0; i < elementCount; i++) {
      Element question = (Element)elements.item(i);
      String type=sys.xml.getTxt(question,"type");
      String qid=sys.xml.getTxt(question,"qid");
      try { totalpoints+=sys.xml.getInt(question,"points"); } 
      catch (Exception e1){ throw new Exception("Missing quiz information, please report; points are not specified.");}
      try {
	Hashtable responseht= (Hashtable) ht.get(qid);
	if (responseht==null) responseht = new Hashtable();
	if (type.equals("mc"))
	  totalscore+=gradeMC (eXam,question,responseht);
	else if (type.equals("prg"))
	  totalscore+=gradePrg (eXam,question,responseht);
      } catch (Exception e2){}
    }
    
    Element quiz=sys.xml.get(eXam,"quiz"); 
    int finalscore=totalscore;
    if (allquestions) {
      int qzpoints=sys.xml.getInt(quiz,"points");
      finalscore=totalscore*qzpoints/totalpoints;
    }
    sys.xml.addMyTextNode(eXam,quiz,"std-total"   ,Integer.toString(finalscore));
    return finalscore;
  }

 //%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  // gradePrg
  //%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  public static int gradePrg(Document d,Element question, Hashtable ht) throws Exception {
    String w=(String)ht.keys().nextElement();
    String g=(String)ht.get(w);
    sys.xml.addMyTextNode(d,question,"std-wrote"   , w);
    sys.xml.addMyTextNode(d,question,"std-score"   ,g);
    if (!g.equals("NaN")) return Integer.parseInt(g);
    return 0;
  }

 //%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  // gradeMC from xtakeexam
  //%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  public static int gradeMC(Document d,Element question, Hashtable ht) throws Exception {
	int points=sys.xml.getInt(question,"points");
	int qscore=0;

	NodeList answers = question.getElementsByTagName("answer");
	int ansCount = answers.getLength();
	for (int a = 0; a < ansCount; a++) {
	  Element answer = (Element)answers.item(a);
	  String text=sys.xml.getTxt(answer,"text");
	  if (ht.get(text)!= null) {
	    int val=sys.xml.getInt(answer,"val");
	    qscore+=val;
	    sys.xml.addMyTextNode(d,answer,"std-selected"   ,"YES");
	  }
	}
	String scoring=sys.xml.getTxt(question,"scoring");
	int stdscore=0;
	if (scoring.equals("nc") && qscore < points)  {
	   stdscore=0;
	} else {
	  stdscore=qscore;
	}
	sys.xml.addMyTextNode(d,question,"std-score"   ,Integer.toString(stdscore));
	return stdscore;
  }

 //%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  // 
  //%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  void  returnQuizResults(PrintWriter printer, String unum, 
		   String course,String quizname,HttpServletRequest req) throws Exception
  {
    dbxQuiz dxq = new dbxQuiz(course,quizname);
    dbxAnswers dxa = new dbxAnswers(course,quizname);
    //    dxa.getGrades(dxq.doc);
    dxa.getGradesNames(dxq.doc);

    parseXML(printer,unum,dxq.doc,"quizRESULT","takenExam");

  }  
 //%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  // 
  //%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  void  returnQuestionResults(PrintWriter printer, String unum, 
		   String course,String quizname,String qid,HttpServletRequest req) throws Exception
  {
    dbxQuestion dxq = new dbxQuestion(course,quizname,qid);
    dbxAnswers dxa = new dbxAnswers(course,quizname);
    dxa.getQuestionAnswers(dxq.doc,qid);

    parseXML(printer,unum,dxq.doc,"questionANSWERS","takenExamQL");

  }  

 //%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  // 
  //%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  void  returnStudents(PrintWriter printer, String unum, 
		   String course,String quizname,HttpServletRequest req) throws Exception
  {
    dbxQuiz dxq = new dbxQuiz(course,quizname);
    dbxAnswers dxa = new dbxAnswers(course,quizname);
    dxa.getGradesNames(dxq.doc);

    parseXML(printer,unum,dxq.doc,"quizRESULTSTUDENTS","takenExam.STUDENTS");

  }  
  //%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  // 
  //%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  void  handGradeQn(PrintWriter printer, String unum, String accesscode, 
			 String course,String quizname,String qid,String score ) throws Exception
  {
    dbxAnswers dxa = new dbxAnswers(accesscode,course,quizname);
    dxa.storeAnswersGrade(score,qid);
    // printer.println("<script language=JavaScript> opener.top.menu.location.reload();  </script><body bgcolor='red'><font color=white><b><center>Score changed for question # "+qid+"<form><input type='button' value='OK' onClick='self.close()'></form>");
    returnXML (printer,"Score changed for question # "+qid,"quizGradeChanged"); 
  }  

} //CLASS xQGrader close


	
