package gs.admin;

import org.w3c.dom.*;

import java.io.PrintWriter;
import java.io.IOException;

import javax.servlet.ServletException;
import javax.servlet.ServletOutputStream;

import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import gs.dbxml.dbxQuiz;
import gs.dbxml.dbxQuestion;
import gs.dbxml.dbxAnswers;
import gs.db.dbStudent;

import java.util.Hashtable;
import java.util.Enumeration;


import java.lang.Character;

/**
 */
public class xTakeExam extends xGeneric {

    /**
     * Service the request.
     *
     * @exception  ServletException if there is any sort of Exception
     *
     */
  public  xTakeExam(){SERVICESTATION="TAKEEXAM-OPEN";}
  public void  serveCommand(PrintWriter printer,
			    String unum,
			    String course,
			    String command,
			    HttpServletRequest req) throws Exception
  {
    String quizname=req.getParameter("quizname");

    if(command.equals("LIST")) 
      listQuizzes(printer, unum, course,  false);

    else if(command.equals("LISTQUESTIONS"))  //need to be more secured in students,view
      {
	dbxQuestion dxq = new dbxQuestion(course,quizname );
	parseXML(printer,unum,dxq.doc,"questionEXAMLIST","listQuestions");
      }
    else { 
      /////////////////////////////////////////////////////
      boolean FORCE=false; //student
      String accesscode;
      
      if (isNumber(unum)) {
	accesscode=dbStudent.getAccesscode(unum);
      }else{ //instructor
	accesscode=req.getParameter("accesscode");
	if (accesscode==null) accesscode="{i}-"+unum;
	FORCE=true;
	System.out.println("\n\n\n\nForcing\n\n\n\n");
      }
      /////////////////////////////////////////////////////
      if(command.equals("PROCESSEXAM")) 
	{
	  processExam(printer,unum,accesscode,course,quizname,req,FORCE);
	}
      else if(command.equals("TAKEQUIZ")) 
	{
	  Document edoc=dbxQuiz.makeExam(course,quizname,FORCE);
	  parseXML(printer,unum,edoc,"quizEXAMTIME","takingExam");
	}
      else if(command.equals("LISTGRADEDQUESTIONS"))
	{
	  returnQuestionGrades(printer,unum,accesscode,course,quizname,req,FORCE);
	}
      else if(command.equals("GRADEEXAM")) 
	{
	  returnGradedExam(printer,unum,accesscode,course,quizname,req,FORCE);
	}
    }
  }
  boolean isNumber(String str){
    char[] s=str.toCharArray();
    if (Character.isLetter(s[0]) && (s[0]!='-'))
      return false;
    for (int i=1;i<str.length();i++)
      if ( Character.isLetter(s[0]) )
	return false;
    return true;
  }

  //%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  // listQuizzes
  //%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  void listQuizzes (PrintWriter printer, String unum, 
		    String course,  boolean allFields)
       throws Exception, IOException 
  {
    dbxQuiz dxq = new dbxQuiz();
    Document d= dxq.listQuizzesInXML( course );
    parseXML(printer,unum,d,"quizEXAMLIST","listQuizzes");
  }
  //%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  // storeResults
  //%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  public Hashtable storeResults(dbxAnswers dxa,HttpServletRequest  req) throws Exception {

    dxa.clear();
    Hashtable ht=new Hashtable();

    for (Enumeration e = req.getParameterNames() ; e.hasMoreElements() ;) {
      String name=(String)e.nextElement();
      //System.out.println("PARAMETER\t"+name);
      if ( name.startsWith ("ans")) {
	String qid=name.substring(3);
	String [] stdans=req.getParameterValues(name);
	String merge="";
	if (stdans !=null) {
	  Hashtable qht= new Hashtable();
	  for (int i=0;i<stdans.length;i++) {
	    qht.put(stdans[i],"NaN");
	    merge+=stdans[i]+"<|>";
	  }
	  ht.put(qid,qht);
	}
	dxa.storeAnswers(merge,qid);
      }
    }
    return ht;
}


 //%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  // processExam
  //%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  void  processExam(PrintWriter printer,  String unum,String accesscode, 
		   String course,String quizname,HttpServletRequest req,boolean FORCE) throws Exception
  {
   dbxQuiz dxq = new dbxQuiz(course,quizname);

    if (FORCE||dxq.available()) {
      Document edoc=dbxQuiz.makeExam(dxq);
      dbxAnswers dxa = new dbxAnswers(accesscode,course,quizname);
      int score=xQGrader.grade(edoc,storeResults(dxa,req),true );
      //   int score=grade(accesscode,course,quizname,edoc,dxa.getAnswers(accesscode,course,quizname) );
      dxa.storeGrade(score);

      if (dxq.published()||FORCE){
	parseXML(printer,unum,edoc,"quizEXAMGRADED","takenExam");
      } else {
	parseXML(printer,unum,edoc,"quizNOT","notpublished");
      }
    } else {
      parseXML(printer,unum,null,"quizNOT","notavailable");
    }
  }  

  //%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  // 
  //%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  void  returnGradedExam(PrintWriter printer, String unum, String accesscode, 
			 String course,String quizname,HttpServletRequest req,boolean FORCE) throws Exception
  {
    dbxQuiz dxq = new dbxQuiz(course,quizname);
    String  function="takenExam";
    if (FORCE)  function="takenExam.CHANGEBLE"; 
    if (FORCE ||  ( dxq.published() &&dxq.afterExam())) {
      Document edoc=dbxQuiz.makeExam(dxq);
      dbxAnswers dxa = new dbxAnswers(accesscode,course,quizname);
      //int score=grade(unum,course,quizname,edoc,storeResults(dxa,req) );
      int score=xQGrader.grade(edoc,dxa.getAnswers(accesscode,course,quizname),true );
      dxa.storeGrade(score);
      Element std=sys.xml.addMyNode(edoc,"student");
      sys.xml.addMyTextNode(edoc,std,"accesscode",accesscode);
      parseXML(printer,unum,edoc,"quizEXAMGRADED", function);
    } else {
      //parseXML(printer,unum,null,"quizNOTPUBLISHED","takenExam");
      //printer.println("<html><body bgcolor=white><font color=red><p>Quiz results are not published yet");
      throw new Exception("Exam results are not published yet");
    }
    
    //parseXML(printer,unum,null,"quizNOT","notavailable");
  }  
  //%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  // 
  //%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  void  returnQuestionGrades(PrintWriter printer, String unum, String accesscode, 
			     String course,String quizname,HttpServletRequest req,boolean FORCE) throws Exception
  {
    dbxQuiz dxq = new dbxQuiz(course,quizname);
    if (FORCE||( dxq.published() &&dxq.afterExam())) {
      Document edoc=dbxQuiz.makeExam(dxq);
      dbxAnswers dxa = new dbxAnswers(accesscode,course,quizname);
      int score=xQGrader.grade(edoc,dxa.getAnswers(accesscode,course,quizname),true );
      //int score=grade(unum,course,quizname,edoc,storeResults(dxa,req) ); //dxa.storeGrade(score);
      parseXML(printer,unum,edoc,"quizQUESTIONSCORES-S","listGradedQuestions");
      System.out.println("-Rr-");
    } else if (dxq.afterExam()) {
      dbxQuestion dxqn = new dbxQuestion(course,quizname );
      parseXML(printer,unum,dxqn.doc,"questionEXAMLIST","listQuestionsNOLINK");
      System.out.println("R");
    } else {
      //dbxQuestion dxqn = new dbxQuestion(course,quizname );
      parseXML(printer,unum,null,"questionEXAMLIST","listQuestionsNOLINK");
      System.out.println("r");
    }
  }  

  //   public Hashtable storeGetAnswersMC(HttpServletRequest  req, String qid) throws Exception {
  //     Hashtable ht=new Hashtable();
  //     dbxAnswers dxa = new dbxAnswers(course,quizname);
  //     for (Enumeration e = req.getParameterNames() ; e.hasMoreElements() ;) {
  //       String name=e.nextElement();
  // 	System.out.println(name);
  // 	if ( name.startsWith ("ans")) {
  // 	  String [] stdans=req.getParameterValues(name);
  // 	  if (stdans !=null) 
  // 	    for (int i=0;i<stdans.length;i++) {
  // 	      ht.put(stdans[i],qid);
  // 	      System.out.println("ht.put(stdans[i],qid);   "+stdans[i]);
  // 	    }
  // 	}
  // 	return ht;
  //     }

} //class close

