package gs.conf;
import java.io.*;
import java.io.IOException;

import java.util.Hashtable;
import java.util.Enumeration ;

import javax.servlet.http.HttpServletRequest;

import gs.cache.*;
import gs.admin.*;
import gs.db.JDBC;
import gs.admin.gAdmin;

public class Configuration {
  public static String configurationFileLOAD="configuration.dat";
  public static String configurationFileSAVE="configuration.dat";
  public static boolean LOADED=false;
  public Configuration(){
     configurationFileSAVE=configurationFileLOAD=System.getProperty("conf","configuration.dat");
     //configurationFileSAVE=configurationFileLOAD="/usr/people/marekp/gs/classes/gs/conf/configuration.dat";
  }
  
  public static void setConfiguration(HttpServletRequest req)     
       throws Exception, IOException 
  {
    configurationFileLOAD=req.getParameter("CONFILELOAD");
    if (configurationFileLOAD != null && !configurationFileLOAD.equals(""))
      { LOADED=false; loadConfiguration(); }
    configurationFileSAVE=req.getParameter("CONFILESAVE");
    
    gSystem.ELogFile=req.getParameter("ERRORLOGFILE");
    if (gSystem.ELogFile != null && !gSystem.ELogFile.equals(""))
      gSystem.openErrorLogFile();
    else  gSystem.closeErrorLogFile();

    gSystem.AccessLogFile=req.getParameter("ACCESSLOGFILE");
    if (gSystem.AccessLogFile != null && !gSystem.AccessLogFile.equals(""))
      gSystem.openAccessLogFile();
    else  gSystem.closeAccessLogFile();

    gSystem.host=req.getParameter("HOST");
    gSystem.home=req.getParameter("HOME");
    gSystem.images=req.getParameter("IMAGES");
    gSystem.htdocs=req.getParameter("HTDOCS");
    gSystem.help=req.getParameter("HELP");
    gSystem.localdir=req.getParameter("LOCALDIR");
    gSystem.cgi=req.getParameter("CGI");
    gSystem.servlet=req.getParameter("SERVLET");
    gSystem.bgcolor=req.getParameter("BGCOLOR");
    gSystem.background=req.getParameter("BACKGROUND");
    gSystem.style=req.getParameter("STYLE");
    gSystem.htpasswd=req.getParameter("HTPASSWD");
    gSystem.pwdfile=req.getParameter("PWDFILE");
    gSystem.DONTASKPWD=!(Boolean.valueOf(req.getParameter("DONTASKPWD"))).booleanValue();

    JDBC.uid=req.getParameter("JUID");
    JDBC.pwd=req.getParameter("JPWD");
    JDBC.driver=req.getParameter("DRIVER");
    String url=req.getParameter("URL");
    if (JDBC.url!=url) 
      gSystem.clearMemory();
    JDBC.url=url;
    StudentCache.size=Integer.parseInt(req.getParameter("SCACHE"));
    AssignmentCache.size=Integer.parseInt(req.getParameter("ACACHE"));
    CourseCache.size=Integer.parseInt(req.getParameter("CCACHE"));
    UserCache.size=Integer.parseInt(req.getParameter("UCACHE"));

    StudentCache.EXPIRE=Integer.parseInt(req.getParameter("EXPIRE"));
    saveConfiguration();
  }
  public static void readConfiguration(Hashtable ht) throws Exception, IOException 
  {
    ht.put("CONFILESAVE",configurationFileSAVE);
    ht.put("CONFILELOAD","");
    ht.put("ERRORLOGFILE",gSystem.ELogFile);
    ht.put("ACCESSLOGFILE",gSystem.AccessLogFile);

    ht.put("HOST",gSystem.host);  
    ht.put("HOME",gSystem.home);
    ht.put("IMAGES",gSystem.images);
    ht.put("HTDOCS",gSystem.htdocs);
    ht.put("HELP",gSystem.help);
    ht.put("LOCALDIR",gSystem.localdir);
    ht.put("CGI",gSystem.cgi);
    ht.put("SERVLET",gSystem.servlet);
    ht.put("DRIVER",JDBC.driver);
    ht.put("URL",JDBC.url);
    ht.put("JUID",JDBC.uid);
    ht.put("JPWD",JDBC.pwd);
 
    ht.put("SCACHE",Integer.toString(StudentCache.size));
    ht.put("ACACHE",Integer.toString(AssignmentCache.size));
    ht.put("CCACHE",Integer.toString(CourseCache.size));
    ht.put("UCACHE",Integer.toString(UserCache.size));

    ht.put("BGCOLOR",gSystem.bgcolor);
    ht.put("BACKGROUND",gSystem.background);
    ht.put("STYLE",gSystem.style);
    ht.put("HTPASSWD",gSystem.htpasswd);
    ht.put("PWDFILE",gSystem.pwdfile);
    ht.put("DONTASKPWD",(new Boolean(!gSystem.DONTASKPWD)).toString());

    ht.put("EXPIRE",Integer.toString(StudentCache.EXPIRE));
  }
  public static void saveConfiguration() throws Exception, IOException 
  {
    PrintWriter conf=null;
    try {
      conf= new PrintWriter
	(new DataOutputStream
	 (new FileOutputStream
	  ( configurationFileSAVE)));
      
    } catch (Exception e) {
      //System.exit(1);
     String em="Configuration File not opened properly to save! <br>\n"+e.getMessage();
      System.out.println(em);
      throw new Exception(em);
    }
    Hashtable ht=new Hashtable();
    readConfiguration(ht);
    Enumeration keys=ht.keys();Enumeration elements=ht.elements();
    while (   keys.hasMoreElements() ) {
      conf.println(keys.nextElement());
      conf.println(elements.nextElement());
    }
    conf.close();
   
  }
  public static void loadConfiguration()
  {
    if (LOADED) return;
    LOADED=true;

    System.out.println("Loading");
    try {
      Hashtable ht=new Hashtable();
      File htmlfile = new File( configurationFileLOAD );

      if(!htmlfile.isFile()) 
	System.out.println("Could not open the file "+configurationFileSAVE+"!");
      else {
	
	BufferedReader lines = 
	  new BufferedReader
	  (new InputStreamReader
	   (new FileInputStream( htmlfile )));
	
	String key, value="", comment="#" ;
	while ( ( key = lines.readLine()) != null  ) {
	  if (key.startsWith(comment)) continue;
	  while ( (value=lines.readLine()) != null ) 
	    if (!value.startsWith(comment)) { 
	      ht.put(key,value);
	      break; 
	    }
	}
      }
      String s="";
      if ( (s=(String)ht.get("CONFILESAVE"))!=null)
	configurationFileSAVE=s;

      if ( (s=(String)ht.get("ERRORLOGFILE"))!=null)
	gSystem.ELogFile=s;
      if (gSystem.ELogFile != null && !gSystem.ELogFile.equals(""))
	gSystem.openErrorLogFile();
      else  gSystem.closeErrorLogFile();

      if ( (s=(String)ht.get("ACCESSLOGFILE"))!=null)
	gSystem.AccessLogFile=s;
      if (gSystem.AccessLogFile != null && !gSystem.AccessLogFile.equals(""))
	gSystem.openAccessLogFile();
      else  gSystem.closeAccessLogFile();
    
      if ( (s=(String)ht.get("HOST"))!=null)
	gSystem.host=s;
      if ( (s=(String)ht.get("HOME"))!=null)
	gSystem.home=s;
      if ( (s=(String)ht.get("IMAGES"))!=null)
	gSystem.images=s;
      if ( (s=(String)ht.get("HTDOCS"))!=null)
	gSystem.htdocs=s;
      if ( (s=(String)ht.get("HELP"))!=null)
	gSystem.help=s;
      if ( (s=(String)ht.get("LOCALDIR"))!=null)
	gSystem.localdir=s;
      if ( (s=(String)ht.get("CGI"))!=null)
	gSystem.cgi=s;
      if ( (s=(String)ht.get("SERVLET"))!=null)
	gSystem.servlet=s;
      if ( (s=(String)ht.get("BGCOLOR"))!=null)
	gSystem.bgcolor=s;
      if ( (s=(String)ht.get("BACKGROUND"))!=null)
	gSystem.background=s;
      if ( (s=(String)ht.get("STYLE"))!=null)
	gSystem.style=s;
      if ( (s=(String)ht.get("HTPASSWD"))!=null)
	gSystem.htpasswd=s;
      if ( (s=(String)ht.get("PWDFILE"))!=null)
	gSystem.pwdfile=s;
      if ( (s=(String)ht.get("DONTASKPWD"))!=null)
	gSystem.DONTASKPWD=!(Boolean.valueOf(s)).booleanValue();
      if ( (s=(String)ht.get("DRIVER"))!=null)
	JDBC.driver=s;
      if ( (s=(String)ht.get("URL"))!=null)
	JDBC.url=s;
      if ( (s=(String)ht.get("JUID"))!=null)
	JDBC.uid=s;
      if ( (s=(String)ht.get("JPWD"))!=null)
	JDBC.pwd=s;

      if ( (s=(String)ht.get("SCACHE"))!=null)
	StudentCache.size=Integer.parseInt(s);
      if ( (s=(String)ht.get("ACACHE"))!=null)
	AssignmentCache.size=Integer.parseInt(s);
      if ( (s=(String)ht.get("CCACHE"))!=null)
	CourseCache.size=Integer.parseInt(s);
      if ( (s=(String)ht.get("UCACHE"))!=null)
	UserCache.size=Integer.parseInt(s);

      if ( (s=(String)ht.get("EXPIRE"))!=null)
	StudentCache.EXPIRE=Integer.parseInt(s);

      if ( (s=(String)ht.get("FIRST_TIME_PASSWORD"))!=null )
	try {gAdmin.insertFirstUser(s);} catch (Exception e) {}

      if ( (s=(String)ht.get("LICENCE_KEY")).equals("12345!#npac_su->jsu(*)-333") )
	System.out.println("Licence KEY is approved..\n");
      else {
	System.out.println("Invalid key!\n");
        System.exit(1);
      }

      System.out.println("Configurations  are loaded from "+configurationFileLOAD+"\n");


    }catch (Exception e) {}
  }
}
