package gs.db;

import gs.db.update;
import gs.db.query;
import java.util.Hashtable;
import java.sql.ResultSet;

public abstract class database {

  public Hashtable fields;
  public String hasval;

  public database() 
  {
    fields = new Hashtable();
  }
  

  abstract public String getTableName();
  abstract public String getFieldNames();
  abstract public String getFieldValues();
  abstract public String getSetValues();
  
  public String getS(String key) {
    String s;
    try                 { s=(String) fields.get(key); } 
    catch (Exception e) { return "";                  }
    if (s==null)        { return "";}
    return s;
  }
  public String getS(String key,String defaultval) {
    String s;
    try                 { s=(String) fields.get(key);   } 
    catch (Exception e) { return defaultval;            }
    if (s==null)        { return defaultval;}
    return s;
  }
  public String get(String key,String q) {
    String s;
    try                 { s= (String) fields.get(key);  } 
    catch (Exception e) { if (q.equals("'")) return "''"; else return "0"; }
    if (s==null)        { if (q.equals("'")) return "''"; else return "0";}
    return q+s+q;
  }
  public boolean has(String key) {
    try                 { hasval=(String) fields.get(key); } 
    catch (Exception e) { return false;                     }
    if (hasval==null)  { return false;                     }
    return true;
  }



  public void openDB() throws Exception{ query.Open(); }
  public void closeDB()throws Exception { query.Close(); }
  public static void closeAll() { query.closeAll(); }
  public String insertSQL() 
  {
    return "INSERT INTO "+ getTableName() + " ("+ getFieldNames() +") "+
       "VALUES ("+ getFieldValues() +")";
  }
  
  public String updateSQL(String whereClause) 
  {
    return "UPDATE "+ getTableName()
      + " SET " + getSetValues()
      + " WHERE " + whereClause;
  }
  public  String updateFieldsSQL(String fields_values,String whereClause) 
  {
    return "UPDATE "+ getTableName()
      + " SET " + fields_values 
      + " WHERE " + whereClause;
  }

  public String deleteSQL(String whereClause) 
  {
    return "DELETE FROM "+ getTableName() 
      +" WHERE "+ whereClause;
  }

  public Hashtable getFields()
  {
    return fields;
  }

  public  ResultSet records(String proj, 
			   String where, 
			   String order) 
       throws Exception 
  {
    if(proj.equals("")) proj = "*";
    if(!where.equals("")) where = " WHERE " + where;
    if(!order.equals("")) order = " ORDER BY " + order;
    
    String queryString = "SELECT "+proj
      +" FROM "+ getTableName() + where + order;

    //System.out.println("database.java.records() " +queryString +" ");
    ResultSet rs = null;
    try {
      rs = query.queryData( queryString );
    } catch(Exception e) {
      throw e; 
    }
    return rs;
  }
  public  ResultSet select(String where) throws Exception 
  {
    String queryString = "SELECT *  FROM "+ getTableName() +" "+where;
    //System.out.println("database.java.select() " +queryString +" ");
    return query.queryData( queryString );
  }
  public static  ResultSet query(String queryString) throws Exception 
  {
    return query.queryData( queryString );
  }

  public void updateAllTables(String updatestr)throws Exception {
    update.updateData( "UPDATE courses "+updatestr);
    update.updateData( "UPDATE questions "+updatestr);
    update.updateData( "UPDATE surveys "+updatestr);
    update.updateData( "UPDATE answers "+updatestr);
    update.updateData( "UPDATE students "+updatestr);
    update.updateData( "UPDATE customizedgrades "+updatestr);
    update.updateData( "UPDATE assignments "+updatestr);
    update.updateData( "UPDATE grades "+updatestr);
    update.updateData( "UPDATE performances "+updatestr);
  }

  public static String null2str(String s)
  {
    if (s==null) return "";
    return s;
  }


}
