package gs.db;
import gs.util.Util ;


import gs.db.update;
import gs.db.database;
import gs.db.query;
import java.util.Hashtable;
import java.sql.ResultSet;

public class dbStudent extends database {

  public       String accesscode;          // unique key
  public       String gspwd    ;
  public       String course;
  public       String idnum;
  public       long  expire;
  
  static       String tablename="students";

  public dbStudent() {}
  public dbStudent(String course) { this.course=course;}
  public dbStudent( String accesscode,String course )        throws Exception
  {
    String queryString = "SELECT * from "+ getTableName() +
       " WHERE accesscode ='"+ accesscode +"' AND course='"+course+"'";
  try {
      ResultSet rs = query.queryData( queryString );
      //System.out.println("dbStudent:queryString:"+queryString);
      if( rs.next() )
	{
	  fields.put("accesscode", Util.null2str(rs.getString("accesscode")));
	  fields.put("oldaccesscode", Util.null2str(rs.getString("accesscode")));
	  fields.put("gspwd", Util.null2str(rs.getString("gspwd")));
	  fields.put("course", Util.null2str(rs.getString("course")));
	  fields.put("studentid", Util.null2str(rs.getString("studentid")));
	  fields.put("idnum", Util.null2str(rs.getString("idnum")));
	  fields.put("firstname", Util.null2str(rs.getString("firstname"))); 
	  fields.put("midname", Util.null2str(rs.getString("midname")));
	  fields.put("lastname", Util.null2str(rs.getString("lastname"))); 
	  fields.put("email", Util.null2str(rs.getString("email"))); 
	  fields.put("dept", Util.null2str(rs.getString("dept"))); 
	  fields.put("url", Util.null2str(rs.getString("url"))); 
	  fields.put("picurl", Util.null2str(rs.getString("picurl"))); 
	  fields.put("class", Util.null2str(rs.getString("class"))); 
	  fields.put("systemslogin", Util.null2str(rs.getString("systemslogin"))); 
	  fields.put("systemspwd", Util.null2str(rs.getString("systemspwd"))); 
	  setIdentification();
	} else {
	 
	  throw new Exception("GS:dbStudent:StudentNotFound: Student could not be found.(dbStudent)");
	}
    } catch(Exception e) {
      //e.printStackTrace();
      throw e;
    }
  }
  
  public void setIdentification(){

     this.accesscode     = (String) fields.get("accesscode");
     this.gspwd     = (String)fields.get("gspwd"); 
     this.course     = (String)fields.get("course"); 

     String idstr= (String)fields.get("idnum"); 
     int Z=idstr.indexOf((int) 'Z');
     if (Z>=0) {
       this.idnum = idstr.substring(0,Z);
       String timeString= idstr.substring(Z+1);
       this.expire =  Long.parseLong(timeString);
     } else {
       this.idnum =idstr;
       //this.expire =-1;
     }

  }
   public void setidnum(String idn){
    fields.put("idnum", idn);
    this.idnum     = idn;
  }
 
  public static dbStudent checkStudentID (String id) throws Exception {
    String queryString = "SELECT accesscode,course from "+ tablename +
       " WHERE idnum like '"+ id +"Z%'";
    try {
      ResultSet rs = query.queryData( queryString );
      //System.out.println("dbStudent:queryString:checkStudentID:"+queryString);
      if( rs.next() )
	{
	  //return Util.null2str(rs.getString("accesscode"));
	  return  new dbStudent(Util.null2str(rs.getString("accesscode")),Util.null2str(rs.getString("course")));
	} else {
	  return null;
	}
    } catch(Exception e) {
      //e.printStackTrace();
      throw e;
    }
  }
  public static String getAccesscode(String id) throws Exception {
    String queryString = "SELECT accesscode from "+ tablename +
      " WHERE idnum like '"+ id +"Z%'";
    ResultSet rs = query.queryData( queryString );
    if( rs.next() )
      return Util.null2str(rs.getString("accesscode"));
    return null;
  }

  public  void makeIDHardCopy()throws Exception {
    update.updateData( "UPDATE "+ getTableName()
      + " SET  idnum='" + idnum+ "Z"+Long.toString(expire)+ "'"
      + " WHERE accesscode='" +accesscode+"' AND course='"+course+"'");
  }
  public static dbStudent  findbyIdNumber(String idnum)  throws Exception {
    //    return new dbStudent(checkStudentID (idnum) );
     return checkStudentID (idnum) ;
    }
 
  public  boolean uniqueness(String []pwcr)  throws Exception {
    String queryString = "SELECT accesscode,gspwd,course from "+ tablename +" WHERE accesscode='"+accesscode+"'";
    ResultSet rs = query.queryData( queryString );
    boolean    unique=true;
    boolean    samecourse=false;
    while ( rs.next() ) {
      unique=false;
      if (course.equals(Util.null2str(rs.getString("course"))))
	samecourse=true;
      pwcr[0]=Util.null2str(rs.getString("gspwd"));
      pwcr[1]=Util.null2str(rs.getString("course"));
    }
    if (samecourse) pwcr[1]=course;
    return unique;
  }
  public static boolean existence(String loginid) throws Exception{
    String queryString = "SELECT accesscode from "+ tablename +" WHERE accesscode='"+loginid+"'";
    ResultSet rs = query.queryData( queryString );
    if( rs.next() )
      return true;
    return false;
  }

  //--------------------------------------------------------------------//
  //--------------------------------------------------------------------//
  //--------------------------------------------------------------------//
  //--------------------------------------------------------------------//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  public   ResultSet listStudents ( boolean allFields) throws Exception
  {
      String queryProjection ="accesscode,firstname,midname,lastname,url";
      if(allFields) 	{
	queryProjection = "*";
      }
      return records(queryProjection,"course='"+course+"'","lastname,firstname");
  }
  public     String  listStudentsFields(boolean allFields ) throws Exception
  {
    if(allFields) 	
      return getFieldNames();
    return "accesscode,firstname,midname,lastname,url";
  }
  

  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  public  ResultSet classList(String course) throws Exception
  {

    String fieldNames = "firstname,midname,lastname,email,url,picurl";
    String queryProjection = fieldNames;
    ResultSet rs = records(queryProjection,"course='"+course+"'", "lastname,firstname");
    return rs;
  }
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  public    String  classListFields(String course) throws Exception
  {
    return "firstname,midname,lastname,email,url,picurl";
  }
 
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  public  ResultSet classPasswordList(String course) throws Exception
  {

    String fieldNames = "accesscode,firstname,midname,lastname,email,url,systemslogin,systemspwd";
    String queryProjection = fieldNames;
    ResultSet rs = records(queryProjection,"course='"+course+"'", "lastname,firstname");
    return rs;
  }
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  public    String  classPasswordListFields(String course) throws Exception
  {
    return "accesscode,firstname,midname,lastname,email,url,systemslogin,systemspwd";
  }
    
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  public String  majordomoList(String course, String []emails) throws Exception
  {
    
emails[0]="";
emails[1]="";
emails[2]="";
    String fieldNames = "firstname,midname,lastname,email,systemslogin";
    String queryProjection = fieldNames;
    ResultSet rs = records(queryProjection,"course='"+course+"'", "lastname,firstname");
    while (rs.next()){
      if ((Util.null2str(rs.getString("systemslogin"))).equals(""))
	emails[1]+=Util.null2str(rs.getString("firstname"))+" "+Util.null2str(rs.getString("midname"))+" "+Util.null2str(rs.getString("lastname"))+"<br>";
      else if ((Util.null2str(rs.getString("email"))).equals(""))
	emails[2]+=Util.null2str(rs.getString("firstname"))+" "+Util.null2str(rs.getString("midname"))+" "+Util.null2str(rs.getString("lastname"))+"<br>";
      else
	emails[0]+=Util.null2str(rs.getString("email"))+",\n";
    
      //course +=course;
    }
    return course;
  }
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  public    String  majordomoListFields(String course) throws Exception
  {
    return "accesscode,firstname,midname,lastname,email,url,systemslogin,systemspwd";
  }
    
  public String postOffice(String course) throws Exception {
    String queryString = "SELECT firstname, midname, lastname,email,url,picurl  from "+ tablename +
      " WHERE course = '"+course +"' ORDER BY lastname,firstname";
    String out="";
    try {
      ResultSet rs = query.queryData( queryString );
      while (rs.next() ) {
	String picurl=Util.null2str(rs.getString("picurl"));
	String url=Util.null2str(rs.getString("url"));
	String name=Util.null2str(rs.getString("lastname"))+", "+Util.null2str(rs.getString("firstname"))+" "+ Util.null2str(rs.getString("midname")) ;
	
	  out+="recipient[n++] = new Recipient('"+name +"' ";
	  out+=",'Students'";
	  out+=",'"+url+"'";
	  out+=",'"+picurl+"'"; 
	  out+=",'"+ Util.null2str(rs.getString("email"))+"');";
      }
    }catch(Exception e) {
      //e.printStackTrace();
      throw e;
    }
    //System.out.println("out++>"+out+" course"+course);
    return out;
  }


  public static Hashtable getFields(String accesscode)  throws Exception
  {
    return new dbStudent(accesscode).getFields(); // super class' method
  }

  public static Hashtable getEmptyFields()
       throws Exception
  {
    Hashtable result = new Hashtable();
    result.put("accesscode", "");
    result.put("gspwd", "");
    result.put("course", "");
    result.put("studentid", "5"); 
    result.put("idnum", ""); 
    result.put("firstname", ""); 
    result.put("midname", "");
    result.put("lastname", ""); 
    result.put("email", ""); 
    result.put("dept", ""); 
    result.put("url", ""); 
    result.put("picurl", ""); 
    result.put("class", ""); 
    result.put("systemslogin","" ); 
    result.put("systemspwd","" ); 

    return result;
  }

  public String getTableName()
  {
    return tablename;
  }
  //<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  // used in SQL INSERT command
  public String getFieldNames()
  {
    return "accesscode,gspwd,course,"+
      "studentid,idnum,"+
      "firstname,midname,lastname,"+
      "email,dept,url,picurl,class,systemslogin,"+
      "systemspwd";
  }

  // used in SQL INSERT command
  public String getFieldValues()
  {
    return                           "'"+ 
      (String)fields.get("accesscode")          +"','"+ 
      (String)fields.get("gspwd")            +"','"+ 
      (String)fields.get("course")            +"','"+ 
      (String)fields.get("studentid")        +"','"+
      (String)fields.get("idnum")              +"','"+
      (String)fields.get("firstname")        +"','"+
      (String)fields.get("midname")          +"','"+ 
      (String)fields.get("lastname")         +"','"+ 
      (String)fields.get("email")            +"','"+
      (String)fields.get("dept")             + "','"+
      (String)fields.get("url")              +"','"+ 
      (String)fields.get("picurl")           +"','"+
      (String)fields.get("class")            +"','"+
      (String)fields.get("systemslogin")     +"','"+
      (String)fields.get("systemspwd")         +"'";
  }

  //>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

  // used in SQL UPDATE command
  public String getSetValues()
  {
    return "accesscode='"          + (String)fields.get("accesscode")
      +"',gspwd='"              + (String)fields.get("gspwd") 
      +"',course='"              + (String)fields.get("course") 
      +"',studentid='"          + (String)fields.get("studentid") 
      +"',idnum='"                + (String)fields.get("idnum") 

      +"',firstname='"          + (String)fields.get("firstname") 
      +"',midname='"            + (String)fields.get("midname") 
      +"',lastname='"           + (String)fields.get("lastname")
      +"',email='"              + (String)fields.get("email") 
      +"',dept='"               + (String)fields.get("dept") 
      +"',url='"                + (String)fields.get("url") 
      +"',picurl='"             + (String)fields.get("picurl") 
      +"',class='"              + (String)fields.get("class") 

      +"',systemslogin='"       + (String)fields.get("systemslogin") 
      +"',systemspwd='"           + (String)fields.get("systemspwd")
      +"'";
  }
  //_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
  //            OPERATIONS
  // \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  public  void changePassword( String accode,String crs, String sysl,String  syspwd )throws Exception{
     update.updateData( 
	    updateFieldsSQL("systemslogin='"+sysl+"',systemspwd='"+syspwd+"'"
			    ,"accesscode='"+accode  +"' AND course='"+crs+"'") );
  }
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //CONSIDER LATER
  public String updateSQL()  throws Exception {
    String oldaccesscode=(String)fields.get("oldaccesscode");
    if (!oldaccesscode.equals(accesscode)) {
      String updatestr=" SET accesscode='"+accesscode+"' WHERE accesscode ='"+oldaccesscode+"' AND course='"+course+"'";
      update.updateData( "UPDATE answers "+updatestr);
      update.updateData( "UPDATE grades "+updatestr);
      update.updateData( "UPDATE performances "+updatestr);
    }
    return updateSQL("accesscode='"+oldaccesscode  +"' AND course='"+course+"'");
  }
  public void update()throws Exception {
      update.updateData( updateSQL() );
  }

  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  public static void  delete(String _accesscode,String _course) throws Exception{
    //    String sqlcommand=new dbStudent().deleteSQL("accesscode='"+ _accesscode +"'");
    //    update.updateData(sqlcommand );
    String deleteStr= "accesscode='"+ _accesscode +"' AND course='"+_course+"'";
    update.updateData( "DELETE FROM students WHERE "+deleteStr);

    update.updateData( "DELETE FROM answers WHERE "+deleteStr);
    update.updateData( "DELETE FROM grades WHERE "+deleteStr);
    update.updateData( "DELETE FROM performances WHERE "+deleteStr);
  }
  //CONSIDER LATER
  //  public String deleteSQL() {
  //   return deleteSQL("accesscode='"+ accesscode +"'");
  //  }

  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  public void add()throws Exception {
      update.updateData( insertSQL() );
  }

}







