package gs.dbxml;

//XML
import com.ibm.xml.parser.*;
import org.w3c.dom.*;
import com.lotus.xsl.*;
import com.lotus.xsl.xml4j.*;
import com.ibm.xml.parsers.*;


import gs.xml.dbXML;
//XML-end
//import gs.conf.default;
import gs.db.update;
import gs.db.database;
import gs.db.query;
import java.util.Hashtable;
import java.sql.ResultSet;



public class dbxQuiz extends database {

  public   String     course  ;          // unique key
  public   String     quizname          ;// unique key
  public   Document   doc;
  static   dbXML      dbx = new dbXML();
  static   String  tablename="quizzes";

  public dbxQuiz() {}

  public dbxQuiz(String course) throws Exception{ 
    fields.put("course", course);
    fields.put("quizname","--!NEW!--" );
    setIdentification();
    generateDocument();
  }

  public  dbxQuiz( String _course,String _quizname ) throws Exception
  {
    this.course=_course;
    this.quizname=_quizname;
    // if in cache 
    //    doc=cache;
    // return;
    String queryString = "SELECT * from "+ getTableName() +
      " WHERE  course='"+_course+"' AND quizname='"+ _quizname +"'";
    try {
      ResultSet rs = query.queryData( queryString );
      System.out.println("\ndbxQuiz:queryString:"+queryString);

      if ( rs.next() )	  {
	fields.put("course" 	 ,			course);
	fields.put("quizname"	 ,			quizname);
	fields.put("starttime"	 ,Util.null2str(rs.getString("starttime")));
	fields.put("endtime"	 ,Util.null2str(rs.getString("endtime")));
	fields.put("duration"	 ,Util.null2str(rs.getString("duration")));
	fields.put("points" 	 ,Util.null2str(rs.getString("points")));
	fields.put("xslfile"	 ,Util.null2str(rs.getString("xslfile")));
	fields.put("settings"	 ,Util.null2str(rs.getString("settings")));
	fields.put("additional"	 ,Util.null2str(rs.getString("additional")));
	setIdentification();
      } else{
	throw new Exception("GS:dbxQuiz:QuizNotFound: Quiz  could not be found!");
      }
    } catch(Exception e) {
      e.printStackTrace();
      throw e;
    }
    generateDocument();
  }
  

  public void setIdentification(){
     this.quizname     = getS("quizname"); 
     this.course     = getS("course"); 
  }

  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//

  //%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  // QuizInXML
  //%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  public Document QuizInXML(  )        throws Exception
  {
    //get from  cache 
    if (doc==null) {
      convert2XML(  ) ; //put into cache
    }
    return doc;
  }

  //%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  // generateDocument
  //%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  public Document generateDocument() throws Exception {
    System.out.println("BEGIN:generateDocument");
    try {
      Document d=dbx.giveMeEmptyDocument(); 
      Element crs=dbx.makeMeRoot(d,"course"); 

      dbx.addMyTextNode(d,crs,"coursename"   ,course);

      Element quiz= dbx.addMyNode(d,crs,"quiz");
      dbx.addMyTextNode(d,quiz,"quizname"    ,quizname);
      dbx.addMyTextNode(d,quiz,"starttime"   ,getS("starttime"));
      dbx.addMyTextNode(d,quiz,"endtime"     ,getS("endtime"));
      dbx.addMyTextNode(d,quiz,"duration"    ,getS("duration"));
      dbx.addMyTextNode(d,quiz,"points"      ,getS("points"));
      dbx.addMyTextNode(d,quiz,"xslfile"     ,getS("xslfile"));
      System.out.println("!---------"+getS("settings")+"---------");
      dbx.addMySubTree (d,quiz,getS("settings"));
      dbx.addMyTextNode(d,quiz,"additional"  ,getS("additional"));

      //                          GET available  XSL LAYOUTS
      Element layouts       = dbx.availableLayouts(d,"quiz");
      Element currentLayout = dbx.getLayout(d,course,"quiz");
      layouts.appendChild(currentLayout);
      crs.appendChild(layouts);

      doc=d;

    } catch(Exception e) { 
      System.out.println("\n\n Exception  785: Quiz !  \n\n");
      e.printStackTrace();
      throw e;
    }
     System.out.println("END:generateDocument");   
    return doc;
  }

  //%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  // convert2XML
  //%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  public Document convert2XML(  )        throws Exception
  {
    course= getS("course");
    quizname=getS("quizname");
    String starttime  = getS("starttime");
    String endtime    = getS("endtime");
    String duration   = getS("duration");
    String points     = getS("points");
    String xslfile   = getS("xslfile"); //luxury
    //String qexslfile   = getS("exslfile"); //luxury
    String settings   = getS("settings");
    String additional = getS("additional");

    Document d=dbx.giveMeEmptyDocument();  
    Element crs=dbx.makeMeRoot(d,"course"); 
    dbx.addMyTextNode(d,crs,"coursename"   ,course);
    Element quiz= dbx.addMyNode(d,crs,"quiz");
    dbx.addMyTextNode(d,quiz,"quizname"   ,quizname);
    dbx.addMyTextNode(d,quiz,"duration"   ,duration);
    dbx.addMyTextNode(d,quiz,"points"     ,points);
    dbx.addMyTextNode(d,quiz,"xslfile"    ,xslfile);
    dbx.addMySubTree(d,quiz,settings);
    //dbx.addMyTextNode(d,quiz,"settingsI"  ,settingsI);
    dbx.addMyTextNode(d,quiz,"additional" ,additional);
    //GET available  XSL LAYOUTS
    Element layouts=dbx.availableLayouts(d,"quiz");
    Element currentLayout=dbx.getLayout(d,course,"quiz");
    layouts.appendChild(currentLayout);
    crs.appendChild(layouts);
  
    doc=d;
    return doc;
  }
  //%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  // convert2DB
  //%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  public void  convert2DB(  )        throws Exception
  {
    Element p=doc.getDocumentElement() ;
    course= dbx.getVal(p,"/course/coursename");
    quizname=dbx.getVal(p,"/course/quiz/quizname");
    String starttime  = dbx.getVal(p,"/course/quiz/starttime");
    String endtime    = dbx.getVal(p,"/course/quiz/endtime");
    String duration   = dbx.getVal(p,"/course/quiz/duration");
    String points     = dbx.getVal(p,"/course/quiz/points");
    String xslfile    = dbx.getVal(p,"/course/quiz/xslfile");
    //  String settings   = p.getTreeVal("/course/quiz/settings");
    String additional = dbx.getVal(p,"/course/quiz/additional");
    String settings ="";
    fields.put("course",course );
    fields.put("quizname",quizname );
    fields.put("starttime",starttime );
    fields.put("endtime",endtime );
    fields.put("duration",duration );
    fields.put("points",points );
    fields.put("xslfile",xslfile );
    fields.put("settings",settings );
    fields.put("additional",additional );



  }

  //%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  // listQuizzesInXML
  //%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  public Document listQuizzesInXML( String course) throws Exception
  {
    String queryString =   "SELECT * from "+ getTableName() 
      + " WHERE course='"+course+"'";
    
    Document d=dbx.giveMeEmptyDocument(); 
    Element crs=dbx.makeMeRoot(d,"course"); 
    dbx.addMyTextNode(d,crs,"coursename"   ,course);
    try {
      ResultSet rs = query.queryData( queryString );
      System.out.println("\nlistQuizzesInXML:QueryString:"+queryString);

      while ( rs.next() ) {
	String quizname   = Util.null2str(rs.getString("quizname")); //luxury
	String starttime  = Util.null2str(rs.getString("starttime"));
	String endtime    = Util.null2str(rs.getString("endtime"));
	String duration   = Util.null2str(rs.getString("duration"));
	String points     = Util.null2str(rs.getString("points"));
	String xslfile    = Util.null2str(rs.getString("xslfile")); //luxury
	String settings   = Util.null2str(rs.getString("settings"));
	String additional = Util.null2str(rs.getString("additional"));

	Element quiz= dbx.addMyNode(d,crs,"quiz");
	dbx.addMyTextNode(d,quiz,"quizname"   ,quizname);
	dbx.addMyTextNode(d,quiz,"duration"   ,duration);
	dbx.addMyTextNode(d,quiz,"points"     ,points);
	dbx.addMyTextNode(d,quiz,"xslfile"    ,xslfile);
	dbx.addMySubTree(d,quiz,settings);
	dbx.addMyTextNode(d,quiz,"additional" ,additional);
      }
      //GET available  XSL LAYOUTS
      Element layouts=dbx.availableLayouts(d,"quizlist");
      Element currentLayout=dbx.getLayout(d,course,"quizlist");
      layouts.appendChild(currentLayout);
      crs.appendChild(layouts);
    } catch(Exception e) { 
      System.out.println("\n\n [ Exception ] 786: listQuizzesInXML\n\n");
      e.printStackTrace();
      throw e;
    }
    return d;
  }

  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@  fields @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//

  // @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @
  public String getTableName()
  {
    return tablename;
  }

  // @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @
  public String getFieldNames() //used in SQL INSERT command
  {
    return "course,quizname,starttime,endtime,duration,points,xslfile,settings,additional";
  }

  // @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @
 public String getFieldValues()  // used in SQL INSERT command
  { 
    return                            "'"+ 
      getS("course")               +"','"+ 
      getS("quizname")             +"','"+ 
      getS("starttime")            +"','"+ 
      getS("endtime")              +"','"+
      getS("duration")             +"','"+
      getS("points")               +"','"+
      getS("xslfile")              +"','"+ 
      getS("settings")             +"','"+ 
      getS("additional")           +"'";
  }

  // @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @
  public static Hashtable getEmptyFields()
       throws Exception
  {
    Hashtable result = new Hashtable();
    result.put("course"    , "");
    result.put("quizname"  , "");
    result.put("starttime" , "");
    result.put("endtime"   , ""); 
    result.put("duration"  , ""); 
    result.put("points"    , ""); 
    result.put("xslfile"   , "");
    result.put("settings"  , ""); 
    result.put("additional", ""); 
    return result;
  }

  // @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @
  public String getSetValues() //  used in SQL UPDATE command
  {
    return "course='"          + getS("course")
      +"',quizname='"          + getS("quizname") 
      +"',starttime='"         + getS("starttime") 
      +"',endtime='"           + getS("endtime") 
      +"',duration='"          + getS("duration") 
      +"',points='"            + getS("points") 
      +"',xslfile='"           + getS("xslfile") 
      +"',settings='"          + getS("settings") 
      +"',additional='"        + getS("additional") 
      +"'";
  }
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@  fields  end @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@ operations @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //=====================================================================UPDATE===
  public void updateDocument2DB()throws Exception {
    update();
    //update  in cache
  }
  //=====================================================================UPDATE===
  // CONSIDER LATER
  public String updateSQL()  throws Exception {

    String   oldquizname  =getS("oldquizname");  
  
    if (!oldquizname.equals(quizname)) {
      //       String updatestr=" SET accesscode='"+accesscode+"' WHERE accesscode ='"
      //                                            +oldaccesscode+"' AND course='"+course+"'";
      //       update.updateData( "UPDATE answers "+updatestr);
      //       update.updateData( "UPDATE grades "+updatestr);
      //       update.updateData( "UPDATE performances "+updatestr);
    }
    return updateSQL("quizname='"+oldquizname  +"' AND course='"+course+"'");
  }


  //=============update========================================================UPDATE===
  public Document update()throws Exception {
     System.out.println("BEGIN:update"); 
     try {
      update.updateData( updateSQL() );
    }
    catch( Exception e ) {
      String error =e.getMessage();
      if (error.indexOf("unique") >=0) {
	error= new String("<b>ERROR [123]</b>: This quizname exists in the system. <br> Please try another one.!");
      }
      throw new Exception(error);
    }    
    generateDocument();
    //put into cache
     System.out.println("END:update"); 
    return doc;
  }

 //==============add===========================================================ADD== 
  public Document  add()throws Exception {
    System.out.println("BEGIN:add"); 
    try {
      update.updateData( insertSQL() );
    }
    catch( Exception e ) {
      String error =e.getMessage();
      if (error.indexOf("unique") >=0) {
	error= new String("<b>ERROR [124]</b>: This quizname exists in the system. <br> Please try another one.!");
      }
      throw new Exception(error);
    }    
    generateDocument();
    //put into cache
     System.out.println("END:add"); 
    return doc;
  }


  //====================================================================delete====== 
  public static void  delete(String _course,String _quizname) throws Exception{
    String deleteStr= "quizname='"+ _quizname +"' AND course='"+_course+"'";
    update.updateData( "DELETE FROM quizzes WHERE "+deleteStr);
    
    //  update.updateData( "DELETE FROM answers WHERE "+deleteStr);
    //  update.updateData( "DELETE FROM grades WHERE "+deleteStr);
    //update.updateData( "DELETE FROM performances WHERE "+deleteStr);
  }


}





