
--------------------------questions----------------------------------4----\g
CREATE TABLE questions	(
	qid			int NOT NULL,
	question		CHAR(300),
	category		CHAR(30)
) \g
CREATE UNIQUE  INDEX index_questions ON questions (
	qid					) \g

--------------------------surveys------------------------------------5--\g
CREATE TABLE surveys	(
	course			char(50) NOT NULL,
	surveyname		char(50) NOT NULL,
	qid			int NOT NULL,
	question		CHAR(300),
	category		CHAR(30)
)\g
CREATE UNIQUE  INDEX index_surveys ON surveys (
        course,surveyname,qid			) \g
--------------------------answers-----------------------------------6---\g
CREATE TABLE answers	(
	course			char(50) NOT NULL,
	surveyname		char(50) NOT NULL,
	accesscode		char(20) NOT NULL,
	qid			int NOT NULL,
	answer			CHAR(3)
)\g
CREATE UNIQUE  INDEX index_answers ON answers (
        course,surveyname,accesscode,qid	) \g

---------------------------QUIZZES-----------------------------------5--\g
---------------------------QUIZZES-----------------------------------5--\g
---------------------------QUIZZES-----------------------------------5--\g
---------------------------QUIZZES-----------------------------------5--\g


---------------------------QUIZZES-----------------------------------5--\g

CREATE TABLE QUIZZES (
	course			char(50) NOT NULL,
	surveyname		char(50) NOT NULL,
	starttime		char(21),
	endtime			char(21),
	duration		char(21),
	points			char(10),
	stylesheet		char(200),
	settings		char(200)
	
) \g
CREATE UNIQUE  INDEX index_questions ON questions (
        course,surveyname		) \g




---------------------------xquestions-----------------------------------5--\g

CREATE TABLE xquestions (
	course			char(50) NOT NULL,
	surveyname		char(50) NOT NULL,
	qid			int NOT NULL,
	qset			CHAR(30),
	qtitle			char(200),
	question		CHAR(300),
	category		CHAR(30),
	format			CHAR(20),
	image			CHAR(200),
	feedback		CHAR(500),
	feedbackformat		CHAR(20),
	type			CHAR(20),
	points			char(10)
	
) \g
CREATE UNIQUE  INDEX index_xquestions ON xquestions (
        course,surveyname,qid			) \g


---------------------------questions-----------------------------------5--\g

CREATE TABLE questionBank (
	qb_qid			int NOT NULL,
	qset			CHAR(30),
	qtitle			char(200),
	question		CHAR(300),
	category		CHAR(30),
	format			CHAR(20),
	image			CHAR(200),
	feedback		CHAR(500),
	feedbackformat		CHAR(20),
	type			CHAR(20),
	points			char(10)
	
) \g
CREATE UNIQUE  INDEX index_questionBank ON questions (
        qb_qid			) \g




------------------------------multiplechoice------------------------------4----\g
CREATE TABLE 	multiplechoice (
	qid			int NOT NULL,
	course			char(50) NOT NULL,
	surveyname		char(50) NOT NULL,
	coiceoption
	scoring_cumulative
	scoring_negative
	layout			CHAR(20)
) \g
CREATE UNIQUE  INDEX index_questions ON questions (
        course,surveyname,qid			) \g


------------------------------mcAnswers------------------------------4----\g
CREATE TABLE 	mcAnswers (
	qid			int NOT NULL,
	course			char(50) NOT NULL,
	surveyname		char(50) NOT NULL,
	format
	value
	valuetype
	feedback
) \g
CREATE UNIQUE  INDEX index_questions ON questions (
        course,surveyname,qid			) \g


------------------------------matching------------------------------4----\g
CREATE TABLE 	matching (
	qid			int NOT NULL,
	course			char(50) NOT NULL,
	surveyname		char(50) NOT NULL,
	markingscheme
	

) \g
CREATE UNIQUE  INDEX index_questions ON questions (
        course,surveyname,qid			) \g

------------------------------matching------------------------------4----\g
CREATE TABLE 	matching (
	qid					int NOT NULL,
	course			char(50) NOT NULL,
	surveyname		char(50) NOT NULL,
	markingscheme
	preview
	firstcolon
	secondcolon
	answer
	

) \g
CREATE UNIQUE  INDEX index_questions ON questions (
        course,surveyname,qid			) \g



------------------------short------------------------------------4----\g
CREATE TABLE 	short (short
	qid			int NOT NULL,
	course			char(50) NOT NULL,
	surveyname		char(50) NOT NULL,
	numofanswers
	

) \g
CREATE UNIQUE  INDEX index_questions ON questions (
        course,surveyname,qid			) \g


------------------------shortAnswers------------------------------------4----\g
CREATE TABLE 	shortAnswers (
	qid			int NOT NULL,
	course			char(50) NOT NULL,
	surveyname		char(50) NOT NULL,
	answer
	value
	allowed

) \g
CREATE UNIQUE  INDEX index_questions ON questions (
        course,surveyname,qid			) \g


---------------------------paragraph---------------------------------4----\g
CREATE TABLE 	paragraph (paragraph
	qid			int NOT NULL,
	course			char(50) NOT NULL,
	surveyname		char(50) NOT NULL,
	lines
	columns
	pretext
	answer
) \g
CREATE UNIQUE  INDEX index_questions ON questions (
        course,surveyname,qid			) \g


---------------------------studentAnswer---------------------------------4----\g
CREATE TABLE 	paragraph (paragraph
	qid			int NOT NULL,
	course			char(50) NOT NULL,
	surveyname		char(50) NOT NULL,
	answer
	score
) \g
CREATE UNIQUE  INDEX index_questions ON questions (
        course,surveyname,qid			) \g


