/**
 * $Id$
 * 
 * Copyright (c) 1999 Lotus Corporation, Inc. All Rights Reserved.
 *				This software is provided without a warranty of any kind.
 * 
 * $State$
 * 
 * @author Scott Boag (scott_boag@lotus.com)
 */
package com.lotus.xsl;

import org.w3c.dom.*;
import org.xml.sax.*;


/**
 * Wraps a DOM attribute list in a SAX AttributeList.
 */
class AttList implements AttributeList
{
  NamedNodeMap m_attrs;
  int m_lastIndex;
  
  AttList(NamedNodeMap attrs)
  {
  m_attrs = attrs;
  m_lastIndex = m_attrs.getLength() - 1;
  }
  
  public int getLength ()
  {
    return m_attrs.getLength();
  }
  
  public String getName (int i)
  {
    return ((Attr)m_attrs.item(m_lastIndex - i)).getName();
  }
  
  public String getType (int i)
  {
    return "CDATA";  // for the moment
  }
  
  public String getValue (int i)
  {
    return ((Attr)m_attrs.item(m_lastIndex - i)).getValue();
  }
  
  public String getType (String name)
  {
    return "CDATA";  // for the moment
  }
  
  public String getValue (String name)
  {
    return ((Attr)m_attrs.getNamedItem(name)).getValue();
  }
  
}
