/**
 * $Id: Constants.java,v 1.5 1998/12/18 18:57:57 sboag Exp $
 * 
 * Copyright (c) 1998-1999 Lotus Corporation, Inc. All Rights Reserved.
 *				This software is provided without a warranty of any kind.
 * 
 * $State: Exp $
 * 
 * @author Scott Boag (scott_boag@lotus.com)
 */
package com.lotus.xsl;
 
/**
 * Primary constants used in the XSLProcessor classes.
 */
public class Constants
{
  /**
  * IDs for XSL element types. These are associated 
  * with the string literals in the XSLProcessor class.
  * Don't change the numbers.
  */
  static final int ELEMNAME_UNDEFINED = -1;
  static final int ELEMNAME_PARAM = 2;
  static final int ELEMNAME_ADDATTRIBUTE = 4;
  static final int ELEMNAME_ANCHOR = 22;
  // static final int ELEMNAME_ANCHOR_PATTERN = 23;
  static final int ELEMNAME_APPLY_TEMPLATES = 50;
  static final int ELEMNAME_USE = 34;
  static final int ELEMNAME_CHILDREN = 6;
  static final int ELEMNAME_CHOOSE = 37;
  static final int ELEMNAME_COMMENT = 59; // my own
  static final int ELEMNAME_CONSTRUCT = 7; // my own
  static final int ELEMNAME_CONTENTS = 8;
  static final int ELEMNAME_COPY = 9;
  static final int ELEMNAME_COPY_OF = 74;
  static final int ELEMNAME_DEFINEATTRIBUTESET = 40;
  // static final int ELEMNAME_DEFINECONSTANT = 29;
  // static final int ELEMNAME_DEFINEMACRO = 10;
  static final int ELEMNAME_DEFINESCRIPT = 11;
  static final int ELEMNAME_DISPLAYIF = 12; // my own
  static final int ELEMNAME_EMPTY = 14;
  static final int ELEMNAME_EVAL = 15;
  static final int ELEMNAME_EXPECTEDCHILDREN = 16;
  static final int ELEMNAME_EXTENSION = 54;
  static final int ELEMNAME_EXTENSIONHANDLER = 63;
  static final int ELEMNAME_FOREACH = 28;
  static final int ELEMNAME_KEY = 31;
  static final int ELEMNAME_IF = 36;
  static final int ELEMNAME_IMPORT = 26;
  static final int ELEMNAME_INCLUDE = 27;
  static final int ELEMNAME_CALLTEMPLATE = 17;
  static final int ELEMNAME_PARAMVARIABLE = 41;
  static final int ELEMNAME_NUMBER = 35;
  static final int ELEMNAME_OTHERWISE = 39;
  static final int ELEMNAME_PI = 58;
  static final int ELEMNAME_PRESERVESPACE = 33;
  static final int ELEMNAME_REMOVEATTRIBUTE = 5;
  static final int ELEMNAME_TEMPLATE = 19;
  static final int ELEMNAME_SORT = 64;
  static final int ELEMNAME_STRIPSPACE = 32;
  static final int ELEMNAME_STYLESHEET = 25;
  static final int ELEMNAME_TEXT = 42;
  static final int ELEMNAME_VALUEOF = 30;
  static final int ELEMNAME_WHEN = 38;
  
  // Pattern by example support
  static final int ELEMNAME_ROOT = 44;
  static final int ELEMNAME_ANY = 45;
  static final int ELEMNAME_ELEMENT = 46;
  static final int ELEMNAME_TARGETELEMENT = 47;
  static final int ELEMNAME_ATTRIBUTE = 48;
  static final int ELEMNAME_TARGETATTRIBUTE = 49;
  static final int ELEMNAME_URL = 52; // my own

  static final int ELEMNAME_CALL = 55; // my own
  // static final int ELEMNAME_PARAM = 56;
  static final int ELEMNAME_FALLBACK = 57; // my own

  static final int ELEMNAME_TARGETPI = 60; // my own
  static final int ELEMNAME_TARGETCOMMENT = 61; // my own
  static final int ELEMNAME_TARGETTEXT = 62; // my own

  static final int ELEMNAME_CSSSTYLECONVERSION = 65; // my own

  static final int ELEMNAME_COUNTER = 66;
  static final int ELEMNAME_COUNTERS = 67;
  static final int ELEMNAME_COUNTERINCREMENT = 68;
  static final int ELEMNAME_COUNTERRESET = 69;
  static final int ELEMNAME_COUNTERSCOPE = 71;
  static final int ELEMNAME_APPLY_IMPORTS = 72;

  static final int ELEMNAME_VARIABLE = 73;
  static final int ELEMNAME_MESSAGE = 75;
  static final int ELEMNAME_LOCALE = 76;

  // Next free number: 77
 
  /**
  * Literals for XSL element names.  Note that there are more
  * names than IDs, because some names map to the same ID.
  */
  public static final String ELEMNAME_ARG_STRING = "arg";
  // static final String ELEMNAME_ANCHOR_PATTERN_STRING = "anchor-pattern";
  public static final String ELEMNAME_ANCHOR_STRING = "anchor";
  public static final String ELEMNAME_APPLY_TEMPLATES_STRING = "apply-templates";
  public static final String ELEMNAME_APPLY_IMPORTS_STRING = "apply-imports";
  public static final String ELEMNAME_USE_STRING = "use";
  public static final String ELEMNAME_CHILDREN_STRING = "children";
  public static final String ELEMNAME_CHOOSE_STRING = "choose";
  public static final String ELEMNAME_COMMENT_STRING = "comment";
  public static final String ELEMNAME_TARGETCOMMENT_STRING = "target-comment";
  public static final String ELEMNAME_CONSTRUCT_STRING = "construct"; // my own
  public static final String ELEMNAME_CONTENTS_STRING = "contents";
  public static final String ELEMNAME_COPY_STRING = "copy";
  public static final String ELEMNAME_COPY_OF_STRING = "copy-of";
  
  public static final String ELEMNAME_ATTRIBUTESET_STRING = "attribute-set";
  
  public static final String ELEMNAME_VARIABLE_STRING = "variable";
  public static final String ELEMNAME_MESSAGE_STRING = "message";
  public static final String ELEMNAME_LOCALE_STRING = "locale";

  public static final String ELEMNAME_DISPLAYIF_STRING = "display-if"; // my own
  public static final String ELEMNAME_EMPTY_STRING = "empty";
  public static final String ELEMNAME_EVAL_STRING = "eval";
  public static final String ELEMNAME_EXPECTEDCHILDREN_STRING = "expectedchildren";
  public static final String ELEMNAME_EXTENSION_STRING = "functions";
  public static final String ELEMNAME_EXTENSIONHANDLER_STRING = "code-dispatcher";
  public static final String ELEMNAME_FOREACH_STRING = "for-each";
  public static final String ELEMNAME_KEY_STRING = "key";
  public static final String ELEMNAME_IF_STRING = "if";
  public static final String ELEMNAME_IMPORT_STRING = "import";
  public static final String ELEMNAME_INCLUDE_STRING = "include";
  public static final String ELEMNAME_CALLTEMPLATE_STRING = "call-template";
  public static final String ELEMNAME_CALLTEMPLATEARG_STRING = "invoke-arg";
  public static final String ELEMNAME_PARAMVARIABLE_STRING = "param-variable";
  public static final String ELEMNAME_NUMBER_STRING = "number";
  public static final String ELEMNAME_OTHERWISE_STRING = "otherwise";
  public static final String ELEMNAME_PI_STRING = "pi";
  public static final String ELEMNAME_TARGETPI_STRING = "target-pi";
  public static final String ELEMNAME_PRESERVESPACE_STRING = "preserve-space";
  public static final String ELEMNAME_SORT_STRING = "sort";
  public static final String ELEMNAME_STRIPSPACE_STRING = "strip-space";
  public static final String ELEMNAME_STYLESHEET_STRING = "stylesheet";
  public static final String ELEMNAME_TRANSFORM_STRING = "transform";
  public static final String ELEMNAME_TEMPLATE_STRING = "template";
  public static final String ELEMNAME_TEXT_STRING = "text";
  public static final String ELEMNAME_TARGETTEXT_STRING = "target-text";
  public static final String ELEMNAME_VALUEOF_STRING = "value-of";
  public static final String ELEMNAME_WHEN_STRING = "when";
  public static final String ELEMNAME_ROOT_STRING = "root"; // pattern-by-example support
  public static final String ELEMNAME_ANY_STRING = "any"; // pattern-by-example support
  public static final String ELEMNAME_ELEMENT_STRING = "element"; // pattern-by-example support
  public static final String ELEMNAME_TARGETELEMENT_STRING = "target-element"; // pattern-by-example support
  public static final String ELEMNAME_ATTRIBUTE_STRING = "attribute"; // pattern-by-example support
  public static final String ELEMNAME_TARGETATTRIBUTE_STRING = "target-attribute"; // pattern-by-example support
  public static final String ELEMNAME_URL_STRING = "uri"; // pattern-by-example support
  
  public static final String ELEMNAME_CALL_STRING = "call";
  public static final String ELEMNAME_PARAM_STRING = "param";
  public static final String ELEMNAME_FALLBACK_STRING = "fallback";

  // Result tree counting
  public static final String ELEMNAME_COUNTER_STRING = "counter";
  public static final String ELEMNAME_COUNTERS_STRING = "counters";
  public static final String ELEMNAME_COUNTERINCREMENT_STRING = "counter-increment";
  public static final String ELEMNAME_COUNTERRESET_STRING = "counter-reset";
  public static final String ELEMNAME_COUNTERSCOPE_STRING = "counter-scope";
  
  // LotusXSL Only
  public static final String ELEMNAME_CSSSTYLECONVERSION_STRING = "css-style-conversion";

  /*---------------------------------------------
  * Literals for XSL attribute names.
  */
  public static final String ATTRNAME_CLASS = "class";
  public static final String ATTRNAME_ATTRIBUTE = "attribute";
  public static final String ATTRNAME_ATTRIBUTE_SET = "attribute-set";
  public static final String ATTRNAME_AMOUNT = "amount";
  public static final String ATTRNAME_ANCESTOR = "ancestor";
  public static final String ATTRNAME_CASEORDER = "case-order";
  public static final String ATTRNAME_CONDITION = "condition";
  public static final String ATTRNAME_COPYTYPE = "copy-type";
  public static final String ATTRNAME_COUNT = "count";
  public static final String ATTRNAME_DATATYPE = "data-type";
  public static final String ATTRNAME_DEFAULTSPACE = "default-space";
  public static final String ATTRNAME_DEFAULT = "default";
  public static final String ATTRNAME_DEPTH = "with-children";
  public static final String ATTRNAME_DIGITGROUPSEP = "digit-group-sep";
  public static final String ATTRNAME_ELEMENT = "element";
  public static final String ATTRNAME_ELEMENTS = "elements";
  public static final String ATTRNAME_EXPR = "expr";
  // public static final String ATTRNAME_EXPR = "expr";
  public static final String ATTRNAME_FORMAT = "format";
  public static final String ATTRNAME_FROM = "from";
  public static final String ATTRNAME_HREF = "href";
  public static final String ATTRNAME_ID = "id";
  public static final String ATTRNAME_IMPORTANCE = "importance";
  public static final String ATTRNAME_INDENTRESULT = "indent-result";
  public static final String ATTRNAME_LETTERVALUE = "letter-value";
  public static final String ATTRNAME_LEVEL = "level";
  public static final String ATTRNAME_LANG = "lang";
  // public static final String ATTRNAME_MACRO = "macro";
  public static final String ATTRNAME_MATCH = "match";
  public static final String ATTRNAME_MODE = "mode";
  public static final String ATTRNAME_NAME = "name";
  public static final String ATTRNAME_NAMESPACE = "namespace";
  public static final String ATTRNAME_NDIGITSPERGROUP = "n-digits-per-group";
  public static final String ATTRNAME_ONLY = "only";
  public static final String ATTRNAME_ORDER = "order";
  public static final String ATTRNAME_PRIORITY = "priority";
  public static final String ATTRNAME_REFID = "refID";
  public static final String ATTRNAME_RESULTNS = "result-ns";
  public static final String ATTRNAME_SELECT = "select";
  public static final String ATTRNAME_SEQUENCESRC = "sequence-src";
  public static final String ATTRNAME_STYLE = "style";
  public static final String ATTRNAME_TEST = "test";
  public static final String ATTRNAME_TOSTRING = "to-string";
  public static final String ATTRNAME_TYPE = "type";
  public static final String ATTRNAME_USE = "use";
  public static final String ATTRNAME_VALUE = "value";
  
  // Atributes on the functions element
  public static final String ATTRNAME_NS = "ns";
  public static final String ATTRNAME_CLASSID = "classid";
  public static final String ATTRNAME_ARCHIVE = "archive";
  public static final String ATTRNAME_CODETYPE = "type";
  public static final String ATTRNAME_CODEBASE = "codebase";
  public static final String ATTRNAME_METHOD = "calls";
  
  // For space-att
  public static final String ATTRVAL_PRESERVE = "preserve";
  public static final String ATTRVAL_STRIP = "strip";
  
  // For indent-result
  public static final String ATTRVAL_YES = "yes";
  public static final String ATTRVAL_NO = "no";
  
  // For letter-value attribute (part of conversion attributes).
  public static final String ATTRVAL_ALPHABETIC = "alphabetic";
  public static final String ATTRVAL_OTHER = "other";
  
  // For level attribute in xsl:number.
  public static final String ATTRVAL_SINGLE = "single";
  public static final String ATTRVAL_MULTI = "multi";
  public static final String ATTRVAL_ANY = "any";
  
  // Integer equivelents for above
  static final int NUMBERLEVEL_SINGLE = 1;
  static final int NUMBERLEVEL_MULTI = 2;
  static final int NUMBERLEVEL_ANY = 3;

  static final int MAX_MULTI_COUNTING_DEPTH = 32;
  
  // some stuff for my patterns-by-example
  public static final String ATTRVAL_THIS = ".";
  public static final String ATTRVAL_PARENT = "..";
  public static final String ATTRVAL_ANCESTOR = "ancestor";
  public static final String ATTRVAL_ID = "id";
  
  // These are used mainly for keys in the pattern lookup table,
  // for those nodes that don't have unique lookup values
  public static final String PSEUDONAME_ANY = "*";
  public static final String PSEUDONAME_ROOT = "/";
  public static final String PSEUDONAME_TEXT = "#text";
  public static final String PSEUDONAME_COMMENT = "#comment";
  public static final String PSEUDONAME_PI = "#pi";
  public static final String PSEUDONAME_OTHER = "*";
 
  // Stuff for sorting
  public static final String ATTRVAL_DATATYPE_TEXT = "text";
  public static final String ATTRVAL_DATATYPE_NUMBER = "number";
  
  public static final String ATTRVAL_ORDER_ASCENDING = "ascending";
  public static final String ATTRVAL_ORDER_DESCENDING = "descending";

  public static final String ATTRVAL_CASEORDER_UPPER = "upper-first";
  public static final String ATTRVAL_CASEORDER_LOWER = "lower-first";

}

/**
 * $Log: Constants.java,v $
 * Revision 1.5  1998/12/18 18:57:57  sboag
 * Added elements & attributes for sorting.
 *
 * Revision 1.4  1998/12/10 03:12:14  sboag
 * LotusXSL Version 13a
 *
 * Revision 1.3  1998/12/09 23:30:04  sboag
 * Another test of the WinCVS System.
 *
 * Revision 1.2  1998/12/09 23:20:45  sboag
 * Just testing the CVS keywords.
 */
