/**
 * $Id: Dispatcher.java,v 1.2 1998/12/10 03:12:12 sboag Exp $
 * 
 * Copyright (c) 1998-1999 Lotus Corporation, Inc. All Rights Reserved.
 *				This software is provided without a warranty of any kind.
 * 
 * $State: Exp $
 * 
 * @author Scott Boag (scott_boag@lotus.com)
 */
package com.lotus.xsl;

import org.w3c.dom.*;

/**
 * This interface represents a dispatcher that can call an extension from 
 * the expression language via the call(name, ...) function.
 */
public interface Dispatcher
{      
  /**
   * Return an object from an extension.
   */
  Object call(String method, Object[] args);

  /**
   * Get the fallback element associated with this dispatcher.
   * (May return null)
   */
  Element getFallbackElement();
  
  /**
   * Tells if a given function is available.
   */
  boolean isFunctionAvailable(String str);

}

/**
 * $Log: Dispatcher.java,v $
 * Revision 1.2  1998/12/10 03:12:12  sboag
 * LotusXSL Version 13a
 *
 */
