package com.lotus.xsl;

import java.util.Vector;

public class Expression
{
  public Expression(String expressionString, String[] tokenQueue, int tokenQueueSize, int patternMap[], int patternMapSize)
  {
    m_tokenQueue = (String[])tokenQueue.clone();
    m_tokenQueueSize = tokenQueueSize;
    m_patternMap = (int[])patternMap.clone();
    m_patternMapSize = patternMapSize;
    m_currentPattern = expressionString;
  }

  /**
   * The current pattern string, for diagnostics purposes
   */
  String m_currentPattern = null;
  int m_tokenQueueSize = 0;

  /**
   *  TokenStack is the queue of used tokens. The current token is the token at the 
   * end of the m_tokenQueue. The idea is that the queue can be marked and a sequence
   * of tokens can be reused.
   */
  String[] m_tokenQueue;
  
  /**
   * This holds a map to the m_tokenQueue that tells where the top-level elements are.
   * It is used for pattern matching so the m_tokenQueue can be walked backwards.
   * Each element that is a 'target', (right-most top level element name) has 
   * TARGETEXTRA added to it.
   */
  int m_patternMap[];
  
  /**
   * The number of elements in m_patternMap;
   */
  int m_patternMapSize;
}
