package com.lotus.xsl;

import org.w3c.dom.*;
import java.io.*;

public interface Formatter
{
  /**
   * Print the result tree.
   * @param doc The result tree.
   * @param pw The PrintWriter to print the contents to.
   * @param resultns the value of the resultns attribute.
   * @param format Tells if it should be pretty-printed.
   * @exception Exception thrown if the result tree is corrupted.
   */
  public void toMarkup(Document doc, PrintWriter pw, String resultns, boolean format)
        throws Exception;
  
  /**
   * Get an instance of the formatter listener that is associated 
   * with this formatter.
   */
  public FormatterListener getFormatterListener();
  
  /**
   * Set an instance of the formatter listener that is associated 
   * with this formatter.
   */
  public void setFormatterListener(PrintWriter pw, String resultns, boolean format);

  /**
   * Set an instance of the formatter listener that is associated 
   * with this formatter.
   */
  public void setFormatterListener(FormatterListener fl);
}
