package com.lotus.xsl;

import org.w3c.dom.*;
import java.util.*;

/**
 * Local implementation of NodeList.  This class is for internal use only.
 */
class NodeListImpl extends Vector implements NodeList
{
  NodeListImpl() 
  {
    super();
  }
  
  /**
   * Add a node.
   */
  void addNode(Node n)
  {
    this.addElement(n);
  }

  /**
   * Remove a node.
   */
  void removeNode(Node n)
  {
    this.removeElement(n);
  }

  /**
   * Returns the <code>index</code>th item in the collection. If 
   * <code>index</code> is greater than or equal to the number of nodes in 
   * the list, this returns <code>null</code>.
   * @param index Index into the collection.
   * @return The node at the <code>index</code>th position in the 
   *   <code>NodeList</code>, or <code>null</code> if that is not a valid 
   *   index.
   */
  public Node item(int index)
  {
    return (Node)this.elementAt(index);
  }
  
  /**
   * The number of nodes in the list. The range of valid child node indices is 
   * 0 to <code>length-1</code> inclusive. 
   */
  public int getLength()
  {
    return this.size();
  }
}
