/**
 * $Id: NodeSortKey.java,v 1.1 1998/12/18 18:56:39 sboag Exp $
 * 
 * Copyright (c) 1998-1999 Lotus Corporation, Inc. All Rights Reserved.
 *				This software is provided without a warranty of any kind.
 * 
 * $State: Exp $
 * 
 * @author Scott Boag (scott_boag@lotus.com)
 */
package com.lotus.xsl;

import org.w3c.dom.*;
import java.util.*;
import java.text.Collator;

/**
 * Simple data structure class for use by the 
 * NodeSorter class.
 */
public class NodeSortKey
{
  String m_selectPat;
  boolean m_treatAsNumbers; 
  boolean m_descending; 
  Collator m_col;
  Locale m_locale;
  Element m_namespaceContext;
  XSLProcessor m_processor; // needed for error reporting.
  
  NodeSortKey(XSLProcessor processor, String selectPat, 
                   boolean treatAsNumbers, 
                   boolean descending, String langValue, 
                   Element namespaceContext) 
    throws XSLProcessorException
  {
    m_processor = processor;
    m_namespaceContext = namespaceContext;
    m_selectPat = selectPat;
    m_treatAsNumbers = treatAsNumbers; 
    m_descending = descending; 
    if(null != langValue)
    {
      m_locale = new Locale(langValue.toUpperCase(), 
                            Locale.getDefault().getDisplayCountry());
      if(null == m_locale)
      {
        // m_processor.warn("Could not find locale for <sort xml:lang="+langValue);
        m_locale = Locale.getDefault();
      }
    }
    else
    {
      m_locale = Locale.getDefault();
    }
    
    m_col = Collator.getInstance(m_locale);
    if(null == m_col)
    {
      m_processor.warn(
        "Could not find Collator for <sort xml:lang="+langValue);
      m_col = Collator.getInstance();
    }
  }
}

/**
 * $Log: NodeSortKey.java,v $
 * Revision 1.1  1998/12/18 18:56:39  sboag
 * New
 *
 */
