/**
 * $Id: ProblemListenerDefault.java,v 1.1 1999/01/15 23:20:26 sboag Exp $
 * 
 * Copyright (c) 1998-1999 Lotus Corporation, Inc. All Rights Reserved.
 *				This software is provided without a warranty of any kind.
 * 
 * $State: Exp $
 * 
 * @author Scott Boag (scott_boag@lotus.com)
 * */
package com.lotus.xsl;

import org.w3c.dom.*;

/**
 * The implementation of the default error handling for 
 * LotusXSL.
 */
public class ProblemListenerDefault implements ProblemListener
{
  public java.io.PrintWriter out = new java.io.PrintWriter(  System.err, true );
  
  public String errorHeader = "Error: ";
  public String warningHeader = "Warning: ";

  public String xslHeader = "XSL ";
  public String xmlHeader = "XML ";
  public String queryHeader = "PATTERN ";
  
  /**
   * The default problem listener.
   */
  public boolean problem(short where, short classification, 
                     Node styleNode, Node sourceNode,
                     String msg, int lineNo, int charOffset)
  {
    out.println(((XMLPARSER == where)
                 ? xmlHeader : (QUERYENGINE == where) 
                               ? queryHeader : xslHeader)+
                ((ERROR == classification)? errorHeader : warningHeader)+
                msg+
                ((null == styleNode)? "" : (", style tree node: "+styleNode.getNodeName())) +
                ((null == sourceNode)? "" : (", source tree node: "+sourceNode.getNodeName()))+
                ((0 == lineNo)? "" : (", line "+lineNo))+
                ((0 == charOffset)? "" : (", offset "+charOffset)));

    return classification == ERROR;
  }
}
