<?xml version="1.0"?> 

<!-- Sample of styling an imagined realestate document. -->
<!-- Note the XSL namespace declaration. -->
<xsl:stylesheet xmlns:xsl="http://www.w3.org/TR/WD-xsl"
      xmlns="http://www.w3.org/TR/REC-html40" result-ns="">

  <!-- The root template... processing begins here.
       The root is not the document element, but the node 
       above the document element that can also have comments, 
       and processing instructions. -->
  <xsl:template match="/">
    <HTML>
     <HEAD>
       <META http-equiv="Content-Type" content="text/html; charset=iso-8859-1"/>
       <META http-equiv="Expires" content="0"/>
       <STYLE TYPE="text/css"> 
          <!-- Create some CSS patterns that will match the 
               HTML elements created below.  This illustrates
               that CSS can be used with XSL. -->
          BODY { font-size:10pt; }
          .cell { font-size:10pt; }
          .listingCaptions { font-size:18pt;} 
          .tableHead { font:bold;} 
       </STYLE>
     </HEAD>
      <BODY>
        <DIV>
          <!-- Call the child of the root, which is at least the 
               document element.  Other children of the root can be 
               comments, and processing instructions. -->
          <xsl:apply-templates/>
        </DIV>
      </BODY>
    </HTML>
  </xsl:template>
    
  <!-- The template for the document element.  This template 
       could be directly embedded in the template above, but 
       it's nice to break large templates up a bit. -->
  <xsl:template match="HOUSES">
    <!-- The '.' context is now the "HOUSES" element -->
    <TABLE border="1" frame="border" rules="all" cellpadding="2">
      <CAPTION class="listingCaptions">Real Estate Listings</CAPTION>
      <COLGROUP>
        <COL width="30" align="right"/>
        <COL padding-left="15"/>
        <COL padding-left="15"/>
        <COL padding-left="15" align="center"/>
      </COLGROUP>
      <THEAD class="tableHead">     
        <TD>Type</TD>
        <TD>Price</TD>
        <TD>Num Beds</TD>
        <TD>Num Baths</TD>
      </THEAD>
      <!-- For each HOUSE element contained in the HOUSES 
           document element, process the content of the 
           xsl:for-each as a template. -->
      <xsl:for-each select="HOUSE">
        <!-- The '.' context is now the "HOUSE" element -->
        <TR>
          <TD class="cell">
              <!-- get the text from the "HOUSETYPE" element -->
              <xsl:value-of select="HOUSETYPE"/>
          </TD>
          <TD class="cell">
            <!-- get the text from the "PRICE" element -->
            <xsl:value-of select="PRICE"/>
          </TD>
          <TD class="cell">
            <!-- get the text from the "BEDROOMS" element -->
            <xsl:value-of select="BEDROOMS"/>
          </TD>
          <TD class="cell">
            <!-- get the text from the "BATHROOMS" element -->
            <xsl:value-of select="BATHROOMS"/>
          </TD>
        </TR>
      </xsl:for-each>
    </TABLE>
  </xsl:template>
  
  <!-- Note how much smaller and manageable this is 
       compared to the equivalent raw HTML. -->
       
</xsl:stylesheet>