<?xml version="1.0"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/XSL/Transform/1.0" 
        xmlns="http://www.w3.org/TR/REC-html40" result-ns="">

<xsl:template match="userdoc">     <!-- first prepare commentary around list -->
  <HTML>
    <HEAD>
      <META http-equiv="Content-Type" content="text/html; charset=iso-8859-1"/>
      <META http-equiv="Expires" content="0"/>
      <TITLE>
        <xsl:for-each select="prolog/title/topic">
          <xsl:apply-templates/>
        </xsl:for-each>
      </TITLE>
      <STYLE TYPE="text/css"> 
        .tipage { padding:6px;text-align:right;background-color:silver;border:1px solid black;} 
        topic { font-size:18pt;font-family:Verdana;font-weight:bold;} 
        .note { padding:6px;border:1px solid black;background-color:#EEEEEE;} 
        .lblbox { padding:6px;border:1px solid black;background-color:#EEEEEE;} 
        .fn { padding:6px;border:1px solid black;background-color:yellow;} 
        .label { text-decoration:underline;font-weight:bold;} 
        .nodb { list-style:disc;}
        .lines { font-family:Verdana, arial, helvetica, sans-serif;}
        hp4, hp9 { text-transform:uppercase;}
      </STYLE>
    </HEAD>
    <BODY bgcolor="#FFFFFF" text="#000000" topmargin="0" leftmargin="0" marginwidth="0" marginheight="0">
     <font face="Arial, Helvetica, Sans-Serif">
      <xsl:apply-templates/>
     </font>
    </BODY>
  </HTML>
</xsl:template> 

<!-- metadata -->
<xsl:template match="prolog">
  <DIV class="tipage">
    <BR d=""/><BR d=""/>
    <BR d=""/><BR d=""/>
    <xsl:apply-templates/>
    <BR d=""/><BR d=""/>
    <B>IBM Logo</B> or other logo
    <BR d=""/><BR d=""/>
  </DIV>
</xsl:template>

<!-- major document sections -->
<xsl:template match="frontm">
    <HR d=""/>
    <xsl:apply-templates/>
</xsl:template> 

<xsl:template match="body">
    <HR d=""/>
    <xsl:apply-templates/>
</xsl:template> 

<xsl:template match="appendix">
    <HR d=""/>
    <xsl:apply-templates/>
</xsl:template> 

<xsl:template match="backm">
    <HR d=""/>
    <xsl:apply-templates/>
</xsl:template> 

<!-- paragraph-like things -->
<xsl:template match="p">
    <P><xsl:apply-templates/></P>
</xsl:template> 

<xsl:template match="note">
    <P class="note"><B>NOTE: </B><xsl:apply-templates/></P>
</xsl:template> 

<xsl:template match="fn">
    <A href="#" onMouseOver="alert('Can we query the Footnote data here?')">*</A>
</xsl:template> 

<xsl:template match="lblbox">
    <DIV class="lblbox">
      <xsl:apply-templates/>
    </DIV>
</xsl:template> 

<!-- labels -->
<xsl:template match="figcap">
    <P><B>FIGURE: 
    <xsl:apply-templates/>
    </B></P>
</xsl:template> 

<xsl:template match="tcap">
    <P><B>TABLE: 
    <xsl:apply-templates/>
    </B></P>
</xsl:template> 

<xsl:template match="label">
    <P class="label"><xsl:apply-templates/>: </P>
</xsl:template> 


<xsl:template match="prolog/title">
  <H2><xsl:apply-templates/></H2>
</xsl:template>

<xsl:template match="title" priority="-1">
  <DIV class="stitle"><xsl:apply-templates/></DIV>
</xsl:template>

<xsl:template match="library">
  <H1><xsl:apply-templates/></H1>
</xsl:template>

<xsl:template match="topic">
  <H2><xsl:apply-templates/></H2>
</xsl:template>

<xsl:template match="author">
  <P><I><xsl:apply-templates/></I></P>
</xsl:template>

<xsl:template match="address">
  <PRE><xsl:apply-templates/></PRE>
</xsl:template>

<xsl:template match="docprof">
  <xsl:apply-templates/></xsl:template>

<xsl:template match="rev">
  <xsl:apply-templates/></xsl:template>

<xsl:template match="erev">
  <xsl:apply-templates/></xsl:template>

<xsl:template match="date">
  <xsl:apply-templates/></xsl:template>

<xsl:template match="revision">
  <xsl:apply-templates/></xsl:template>

<!-- FRONTM special content -->
<xsl:template match="tipage">
  <xsl:apply-templates/></xsl:template>

<!-- DIV-level containers -->
<xsl:template match="vnotice">
  <table border="1" width="500" cellpadding="3"><tr><td>
    <xsl:apply-templates/>
  </td></tr></table>
</xsl:template>

<xsl:template match="preface">
  <TABLE width="620" border="1" cellspacing="0" cellpadding="0">
    <TR><TD valign="top" width="620"><A href="../index.html">
      <IMG src="intramasthead.gif" align="TOP" width="620" height="50" border="0"/>
    </A></TD></TR>
    <TR><TD VALIGN="TOP" WIDTH="620" HEIGHT="24">
    <xsl:apply-templates/>
    </TD></TR>
    <TR><TD VALIGN="TOP" WIDTH="620" HEIGHT="24"><A
      HREF="/" target="_top"><IMG
      SRC="images/footer_w3.gif" ALT="w3.ibm.com" WIDTH="78" HEIGHT="22" BORDER="0"/></A><IMG
      SRC="images/footer_blank_bar.gif" WIDTH="213" HEIGHT="22" BORDER="0"/><A
      HREF="/search" target="_top"><IMG
      SRC="images/footer_search.gif" ALT="Search" WIDTH="75" HEIGHT="22" BORDER="0"/></A><A
      HREF="/support" target="_top"><IMG
      SRC="images/footer_support.gif" ALT="Support" WIDTH="75" HEIGHT="22" BORDER="0"/></A><A
      HREF="/feedback/feedback.html" target="_top"><IMG
      SRC="images/footer_feedback.gif" ALT="Feedback" WIDTH="75" HEIGHT="22" BORDER="0"/></A><A
      HREF="/cgi-bin/host?http://www.ibm.com" target="_top"><IMG
      SRC="images/footer_ibm.gif" ALT="www.ibm.com" WIDTH="96" HEIGHT="22" BORDER="0"/></A></TD></TR>
  </TABLE>
  <BR d=""/>
  <BR d=""/>
</xsl:template>

<xsl:template match="soa">
  <TABLE width="620" border="1" cellspacing="0" cellpadding="0">
    <TR><TD valign="top" width="620"><A href="../index.html">
      <IMG src="intramasthead.gif" align="TOP" width="620" height="50" border="0"/>
    </A></TD></TR>
    <TR><TD VALIGN="TOP" WIDTH="620" HEIGHT="24">
    <xsl:apply-templates/>
    </TD></TR>
    <TR><TD VALIGN="TOP" WIDTH="620" HEIGHT="24"><A
      HREF="/" target="_top"><IMG
      SRC="images/footer_w3.gif" ALT="w3.ibm.com" WIDTH="78" HEIGHT="22" BORDER="0"/></A><IMG
      SRC="images/footer_blank_bar.gif" WIDTH="213" HEIGHT="22" BORDER="0"/><A
      HREF="/search" target="_top"><IMG
      SRC="images/footer_search.gif" ALT="Search" WIDTH="75" HEIGHT="22" BORDER="0"/></A><A
      HREF="/support" target="_top"><IMG
      SRC="images/footer_support.gif" ALT="Support" WIDTH="75" HEIGHT="22" BORDER="0"/></A><A
      HREF="/feedback/feedback.html" target="_top"><IMG
      SRC="images/footer_feedback.gif" ALT="Feedback" WIDTH="75" HEIGHT="22" BORDER="0"/></A><A
      HREF="/cgi-bin/host?http://www.ibm.com" target="_top"><IMG
      SRC="images/footer_ibm.gif" ALT="www.ibm.com" WIDTH="96" HEIGHT="22" BORDER="0"/></A></TD></TR>
  </TABLE>
  <BR d=""/>
  <BR d=""/>
</xsl:template>

<xsl:template match="toc">
  <xsl:apply-templates/></xsl:template>

<xsl:template match="h1">
  <TABLE width="620" border="1" cellspacing="0" cellpadding="0">
    <TR><TD valign="top" width="620"><A href="../index.html">
      <IMG src="intramasthead.gif" align="TOP" width="620" height="50" border="0"/>
    </A></TD></TR>
    <TR><TD VALIGN="TOP" WIDTH="620" HEIGHT="24">
    <xsl:apply-templates/>
    </TD></TR>
    <TR><TD VALIGN="TOP" WIDTH="620" HEIGHT="24"><A
      HREF="/" target="_top"><IMG
      SRC="images/footer_w3.gif" ALT="w3.ibm.com" WIDTH="78" HEIGHT="22" BORDER="0"/></A><IMG
      SRC="images/footer_blank_bar.gif" WIDTH="213" HEIGHT="22" BORDER="0"/><A
      HREF="/search" target="_top"><IMG
      SRC="images/footer_search.gif" ALT="Search" WIDTH="75" HEIGHT="22" BORDER="0"/></A><A
      HREF="/support" target="_top"><IMG
      SRC="images/footer_support.gif" ALT="Support" WIDTH="75" HEIGHT="22" BORDER="0"/></A><A
      HREF="/feedback/feedback.html" target="_top"><IMG
      SRC="images/footer_feedback.gif" ALT="Feedback" WIDTH="75" HEIGHT="22" BORDER="0"/></A><A
      HREF="/cgi-bin/host?http://www.ibm.com" target="_top"><IMG
      SRC="images/footer_ibm.gif" ALT="www.ibm.com" WIDTH="96" HEIGHT="22" BORDER="0"/></A></TD></TR>
  </TABLE>
  <BR d=""/>
  <BR d=""/>
</xsl:template>

<xsl:template match="h2">
  <xsl:apply-templates/></xsl:template>

<xsl:template match="h3">
  <xsl:apply-templates/></xsl:template>

<xsl:template match="h4">
  <xsl:apply-templates/></xsl:template>

<xsl:template match="h5">
  <xsl:apply-templates/></xsl:template>

<xsl:template match="h6">
  <xsl:apply-templates/></xsl:template>

<!-- headings -->

<xsl:template match="vnhd">
  <H1><xsl:apply-templates/></H1>
</xsl:template>

<xsl:template match="h1/title">
  <H1><xsl:apply-templates/></H1>
</xsl:template>

<xsl:template match="h2/title">
  <HR noshade=""/><B><FONT size="+2"><xsl:apply-templates/></FONT></B><BR d=""/>
</xsl:template>

<xsl:template match="h3/title">
  <H3><xsl:apply-templates/></H3>
</xsl:template>

<xsl:template match="h4/title">
  <H4><xsl:apply-templates/></H4>
</xsl:template>

<xsl:template match="h5/title">
  <H5><xsl:apply-templates/></H5>
</xsl:template>

<xsl:template match="h6/title">
  <H6><xsl:apply-templates/></H6>
</xsl:template>

<!-- case of generated titles -->
<xsl:template match="toc/gendtitle">
  <H1>Table of Contents</H1>
  <xsl:apply-templates/></xsl:template>

<xsl:template match="preface/gendtitle">
  <H1>Preface</H1>
  <xsl:apply-templates/></xsl:template>

<xsl:template match="soa/gendtitle">
  <H1>Changes</H1>
  <xsl:apply-templates/></xsl:template>

<!-- divs -->
<xsl:template match="toc/divbody">  <!-- this generates TOC of level 1 titles -->
  <UL><xsl:for-each select="//h1/title"><LI><A href="#{@id}"><xsl:apply-templates/></A></LI></xsl:for-each></UL>
</xsl:template>


<xsl:template match="vnotice/divbody">
    <font face="Sans-Serif, Helvetica, Arial" size="-1">
      <xsl:apply-templates/>
    <P>(C) IBM Corporation, 1999</P>
    <P>Other notices? </P>
    </font>
</xsl:template>

<xsl:template match="preface/divbody">
  <table border="0" width="612" cellpadding="3"><tr><td>
    <blockquote>
      <xsl:apply-templates/>
    </blockquote>
  </td></tr></table>
</xsl:template>

<xsl:template match="soa/divbody">
  <table border="0" width="612" cellpadding="3"><tr><td>
    <blockquote>
      <xsl:apply-templates/>
    </blockquote>
  </td></tr></table>
</xsl:template>

<xsl:template match="h1/divbody">
  <table border="0" width="612" cellpadding="3"><tr><td>
    <blockquote>
      <xsl:apply-templates/>
    </blockquote>
  </td></tr></table>
</xsl:template>

<xsl:template match="h2/divbody">
    <xsl:apply-templates/>
</xsl:template>

<xsl:template match="h3/divbody">
    <xsl:apply-templates/>
</xsl:template>

<xsl:template match="h4/divbody">
    <xsl:apply-templates/>
</xsl:template>

<xsl:template match="h5/divbody">
    <xsl:apply-templates/>
</xsl:template>

<xsl:template match="h6/divbody">
    <xsl:apply-templates/>
</xsl:template>

<xsl:template match="figbody">
    <HR d=""/>
    <xsl:apply-templates/><HR d=""/></xsl:template>

<!-- Modular information -->

<xsl:template match="lers">
  <xsl:apply-templates/>
</xsl:template>

<xsl:template match="le">
  <xsl:apply-templates/></xsl:template>

<xsl:template match="len">
  <HR noshade=""/><B><FONT size="+2"><xsl:apply-templates/></FONT></B><BR d=""/>
</xsl:template>

<xsl:template match="ledi">
  <xsl:choose>
    <xsl:when test="@other">
      <H4><xsl:value-of select="@text"/></H4>
    </xsl:when>
    <xsl:when test="@format">
      <H4>Syntax</H4>
    </xsl:when>
    <xsl:when test="@parms">
      <H4>Parameters</H4>
    </xsl:when>
    <xsl:when test="@example">
      <H4>Examples</H4>
    </xsl:when>
    <xsl:otherwise>
      <BR d=""/>
    </xsl:otherwise>
  </xsl:choose>
  <BLOCKQUOTE>
    <xsl:apply-templates/>
  </BLOCKQUOTE>
</xsl:template>

<!-- Message/code list -->

<xsl:template match="msgl">
    <xsl:apply-templates/></xsl:template>

<xsl:template match="msggroup">
    <P><xsl:apply-templates/></P></xsl:template>

<xsl:template match="msgno">
    <B><xsl:apply-templates/></B> </xsl:template>

<xsl:template match="msg">
    <B><xsl:apply-templates/></B></xsl:template>

<xsl:template match="xpl">
    <BLOCKQUOTE><xsl:apply-templates/></BLOCKQUOTE></xsl:template>

<xsl:template match="uresp">
    <BLOCKQUOTE><xsl:apply-templates/></BLOCKQUOTE></xsl:template>


<xsl:template match="codel">
    <xsl:apply-templates/></xsl:template>

<xsl:template match="codegroup">
    <P><xsl:apply-templates/></P></xsl:template>

<xsl:template match="code">
    <B><xsl:apply-templates/></B> </xsl:template>


<xsl:template match="ul">
    <UL><xsl:apply-templates/></UL></xsl:template>

<xsl:template match="ol">
    <OL><xsl:apply-templates/></OL></xsl:template>

<xsl:template match="sl">
    <UL><xsl:apply-templates/></UL></xsl:template>

<xsl:template match="li" priority="-1"><LI><xsl:apply-templates/></LI></xsl:template>

<xsl:template match="sl/li">
    <LI class="nodb"><xsl:apply-templates/></LI></xsl:template>


<xsl:template match="dl">
  <DL>
    <xsl:apply-templates/>
  </DL>
</xsl:template>

<xsl:template match="dlentry">
    <xsl:apply-templates/></xsl:template>

<xsl:template match="dt">
    <DT><B><xsl:apply-templates/></B></DT> </xsl:template>

<xsl:template match="dd">
    <DD><xsl:apply-templates/></DD> </xsl:template>

<xsl:template match="parml">
  <DL>
    <xsl:apply-templates/>
  </DL>
</xsl:template>

<xsl:template match="parm">
    <xsl:apply-templates/></xsl:template>

<xsl:template match="ptgroup">
    <xsl:apply-templates/></xsl:template>

<xsl:template match="pt">
    <DT><xsl:apply-templates/></DT> </xsl:template>

<xsl:template match="pd">
    <DD><xsl:apply-templates/></DD> </xsl:template>

<!-- exhibits -->

<xsl:template match="lines">
  <PRE class="lines"><xsl:apply-templates/></PRE>
</xsl:template>

<xsl:template match="xmp">
  <PRE><xsl:apply-templates/></PRE>
</xsl:template>

<xsl:template match="fig">
    <xsl:apply-templates/></xsl:template>

<!-- references -->

<xsl:template match="l">
    <A><xsl:apply-templates/></A></xsl:template>

<xsl:template match="hdref">
    <SUP> [crossref "<xsl:value-of select="@refid"/>"]</SUP></xsl:template>

<xsl:template match="fnref">
    <SUP> [footnote "<xsl:value-of select="@refid"/>"]</SUP></xsl:template>

<xsl:template match="figref">
    <SUP> [figure "<xsl:value-of select="@refid"/>"]</SUP></xsl:template>

<xsl:template match="tref">
    <SUP> [table "<xsl:value-of select="@refid"/>"]</SUP></xsl:template>

<!-- table markup -->

<xsl:template match="table">
  <TABLE><xsl:apply-templates/></TABLE></xsl:template>

<xsl:template match="thd">
  <TR><xsl:apply-templates/></TR></xsl:template>

<xsl:template match="row">
  <TR><xsl:apply-templates/></TR></xsl:template>

<xsl:template match="c" priority="-1">
  <TD><xsl:apply-templates/></TD></xsl:template>

<xsl:template match="thd/c">
  <TH align="left"><U><xsl:apply-templates/></U></TH></xsl:template>


<!-- phrases -->

<xsl:template match="q">
  "<xsl:apply-templates/>"</xsl:template>

<xsl:template match="cit">
  <CITE><xsl:apply-templates/></CITE></xsl:template>

<xsl:template match="mv">
  <VAR><xsl:apply-templates/></VAR></xsl:template>

<xsl:template match="pv">
  <VAR><xsl:apply-templates/></VAR></xsl:template>

<xsl:template match="pk">
  <B><xsl:apply-templates/></B></xsl:template>

<xsl:template match="hp0">
  <xsl:apply-templates/></xsl:template>

<xsl:template match="hp1">
  <I><xsl:apply-templates/></I></xsl:template>

<xsl:template match="hp2">
  <B><xsl:apply-templates/></B></xsl:template>

<xsl:template match="hp3">
  <B><I><xsl:apply-templates/></I></B></xsl:template>

<xsl:template match="hp4">
  <SMALL><xsl:apply-templates/></SMALL></xsl:template>

</xsl:stylesheet>
