<?xml version="1.0"?> 

<!-- Hiawatha. -->
<xsl:stylesheet xmlns:xsl="http://www.w3.org/XSL/Transform/1.0"
        xmlns="http://www.w3.org/TR/REC-html40" result-ns=""
        indent-result="yes">

  <!-- Root template - start processing here -->
  <xsl:template match="/">
    <HTML>
     <HEAD>
       <META http-equiv="Content-Type" content="text/html; charset=iso-8859-1"/>
       <META http-equiv="Expires" content="0"/>
       <STYLE TYPE="text/css"> 
          .authorHeader { font-style:italic;} 
          .poemBody { font-family:Verdana;font-size:12pt;color:teal;} 
          .indentedLine { white-space:pre; } 
       </STYLE>
     </HEAD>
     <BODY>
		    <xsl:apply-templates select="TEI.2/TEXT/BODY/DIV0/HEAD"/>
		    <P>
		    By 
		    <SPAN class="authorHeader">
		      <xsl:apply-templates select="TEI.2/TEIHEADER/FILEDESC/TITLESTMT/AUTHOR"/>
		    </SPAN></P>
		    <SPAN class="poemBody">
		      <xsl:apply-templates select="TEI.2/TEXT/BODY//L | TEI.2/TEXT/BODY//PB"/>
		    </SPAN>
      </BODY>
    </HTML>
  </xsl:template>
     
  <xsl:template match="HEAD">
    <H1><xsl:apply-templates/></H1>
  </xsl:template>
   
  <xsl:template match="PB[0]">
		<!-- suppress -->
  </xsl:template>

  <xsl:template match="PB">
		<P d=""/>
  </xsl:template>

  <xsl:template match="L">
    <xsl:apply-templates/><BR d=""/>
  </xsl:template>

  <xsl:template match="L[@REND='indent']">
	  <SPAN class="indentedLine">
	    <xsl:text>&#160;&#160;&#160;&#160;&#160;</xsl:text>
	  </SPAN>
	  <xsl:apply-templates/><BR d=""/>
  </xsl:template>
  
  <xsl:template match="NOTE">
    <!-- Should do something cool with these, but for now I'll leave it blank -->
  </xsl:template>
   
</xsl:stylesheet>