<?xml version="1.0"?> 

<!-- Sample of styling an imagined realestate document. -->
<xsl:stylesheet xmlns:xsl="http://www.w3.org/XSL/Transform/1.0"
       xmlns="http://www.w3.org/TR/REC-html40" result-ns="">
  <xsl:key name="ids" match="RESIDENTIAL-LISTING" use="@ID"/>
  
  <xsl:template match="/">
    <HTML>
     <HEAD>
       <META http-equiv="Content-Type" content="text/html; charset=iso-8859-1"/>
       <META http-equiv="Expires" content="0"/>
       <STYLE TYPE="text/css"> 
          BODY { font-size:10pt; }
          .cell { font-size:10pt; }
          .listingCaptions { font-size:18pt;} 
          .tableHead { font:bold;} 
       </STYLE>
     </HEAD>
      <BODY>
        <DIV>
          <xsl:apply-templates/>
        </DIV>
      </BODY>
    </HTML>
  </xsl:template>
    
  <xsl:template match="RESIDENTIAL-LISTINGS">
    <TABLE border="1" frame="border" rules="all" cellpadding="2">
      <CAPTION class="listingCaptions">Real Estate Listings</CAPTION>
      <COLGROUP>
        <COL width="30" align="right"/>
        <COL padding-left="15"/>
        <COL padding-left="15"/>
        <COL padding-left="15" align="center"/>
        <COL padding-left="15" align="center"/>
        <COL width="100" padding-left="15" align="right"/>
        <COL padding-left="15" align="right"/>
        <COL padding-left="15" align="left"/>
        <COL padding-left="15" align="right"/>
      </COLGROUP>
      <THEAD class="tableHead">     
        <TD>#</TD>
        <TD>Type</TD>
        <TD>Price</TD>
        <TD>Num Beds</TD>
        <TD>Num Baths</TD>
        <TD>Age</TD>
        <TD>County</TD>
        <TD>City</TD>
        <TD>Address</TD>
      </THEAD>
      <xsl:for-each select="RESIDENTIAL-LISTING">
          <TR>
            <TD><xsl:number count="RESIDENTIAL-LISTING" format="1. "/></TD>  
            <TD class="cell">
              <A href="demo_realestate.htm" 
                  target="instructions"
                  onClick="top.frames[0].select('pageArea2.htm', 1, 'demo_realestate.htm', 'samples/realestate2.xsl', 'samples/realestate.xml', '{@ID}')">
                <xsl:value-of select="GENERAL/TYPE"/>
              </A>
            </TD>
            <TD class="cell">
              <xsl:value-of select="GENERAL/PRICE"/>
            </TD>
            <TD class="cell">
              <xsl:value-of select="GENERAL/STRUCTURE/NUM-BEDS"/>
            </TD>
            <TD class="cell">
              <xsl:value-of select="GENERAL/STRUCTURE/NUM-BATHS"/>
            </TD>
            <TD class="cell">
              <xsl:value-of select="GENERAL/AGE"/><xsl:text> </xsl:text>
              <xsl:value-of select="GENERAL/AGE/@UNITS"/>
            </TD>
            <TD class="cell">
              <xsl:value-of select="GENERAL/LOCATION/@COUNTY"/>
            </TD>
            <TD class="cell">
              <xsl:value-of select="GENERAL/LOCATION/CITY"/>
            </TD>
            <TD class="cell">
              <xsl:value-of select="GENERAL/LOCATION/ADDRESS"/>
            </TD>
          </TR>
      </xsl:for-each>
    </TABLE>
  </xsl:template>
  
  <xsl:template match="*" priority="-1"/>
     
</xsl:stylesheet>