<?xml version="1.0"?> 

<!-- Sample of styling an imagined realestate document. -->
<xsl:stylesheet xmlns:xsl="http://www.w3.org/XSL/Transform/1.0"
        xmlns="http://www.w3.org/TR/REC-html40" result-ns="">

  <xsl:key name="ids" match="RESIDENTIAL-LISTING" use="@ID"/>
  
  <xsl:param-variable name="property" expr="dummy"/>
  
  <xsl:template match="/">
    <HTML>
     <HEAD>
       <META http-equiv="Content-Type" content="text/html; charset=iso-8859-1"/>
       <META http-equiv="Expires" content="0"/>
       <STYLE TYPE="text/css"> 
          .listingCaptions { font-size:18pt;} 
          .leftColumn { padding-left:25;} 
          .otherFeatures { margin-bottom:7;} 
          .AdditionalFeaturesHeader { text-decoration:underline;font:italic bold;margin-bottom:7;margin-top:7;} 
       </STYLE>
     </HEAD>
      <BODY>
        <DIV>
          <xsl:apply-templates/>
        </DIV>
      </BODY>
    </HTML>
  </xsl:template>
    
  <xsl:template match="RESIDENTIAL-LISTINGS">
    <xsl:apply-templates select="$property"/>
  </xsl:template>
  
  <xsl:template match="RESIDENTIAL-LISTING">
    <TABLE VALIGN="top">
      <CAPTION class="listingCaptions">Key Features: 
        <xsl:value-of select="GENERAL/PRICE"/>
        Located in <xsl:value-of select="GENERAL/LOCATION/CITY"/>,
        Zip Code: <xsl:value-of select="GENERAL/LOCATION/ZIP"/>
      </CAPTION>
      <COLGROUP>
        <COL/>
        <COL class="leftColumn" width="100%"/>
      </COLGROUP>
      <TR>
        <TD>
          <xsl:for-each select="GENERAL/IMAGE">
            <IMG SRC="images/{@SRC}"/><BR d=""/>
          </xsl:for-each>
        </TD>
        <TD VALIGN="top">
          <P class="otherFeatures">
            This <xsl:value-of select="GENERAL/TYPE"/> has 
            <xsl:value-of select="GENERAL/STRUCTURE/NUM-BEDS"/> bedroom(s),
            <xsl:value-of select="GENERAL/STRUCTURE/NUM-BATHS"/> bath(s),
            and is on <xsl:value-of select="GENERAL/LAND-AREA"/>
            <xsl:text> </xsl:text>
            <xsl:value-of select="GENERAL/LAND-AREA/@UNITS"/>.<BR d=""/>
            <STRONG>MLS#: <xsl:value-of select="GENERAL/MLS/MLS-CODE"/></STRONG>
          </P>
          <P class="AdditionalFeaturesHeader">
            Additional Features<BR d=""/>
          </P>
          <xsl:apply-templates select="FEATURES/*"/>
        </TD>
      </TR>
    </TABLE>
  </xsl:template>
  
  <xsl:template match="UTILITIES">
    Utilities: <xsl:apply-templates/><BR d=""/>
  </xsl:template>
  
  <xsl:template match="EXTRAS">
    <xsl:apply-templates/><BR d=""/>
  </xsl:template>
  
  <xsl:template match="CONSTRUCTION">
    <xsl:apply-templates/><BR d=""/>
  </xsl:template>

  <xsl:template match="ACCESS">
    <xsl:apply-templates/> access<BR d=""/>
  </xsl:template>
  
  <xsl:template match="*" priority="-1"/>
     
</xsl:stylesheet>