<?xml version="1.0"?> 

<!-- stylesheet for testing import and include features -->
<xsl:stylesheet xmlns:xsl="http://www.w3.org/XSL/Transform/1.0">
  <xsl:import href="tei_tables_to_html.xsl"/>
  <xsl:include href="tei_highlights_to_html.xsl"/>
  <xsl:include href="tei_lists_to_html.xsl"/>
  <xsl:include href="tei_header_to_html.xsl"/>
  
  <xsl:template match="doc">
	  <H1>Test for import and include features</H1>
	  <P>Should see a table with rows in blue text, the second row 
	  with a yellow background, the corner empty cell with a black 
	  background, the column headers underlined, and the row headers 
	  in red and underlined.</P>
	  <xsl:apply-templates/>
  </xsl:template>
  
  <!-- This should override the template in tei_tables_to_html.xsl -->
  <xsl:template match="table/row">
	  <TR style="color:blue"><xsl:apply-templates/></TR>
  </xsl:template>

  <xsl:template match="table/row[@test='critical']">
	  <TR style="background-color:yellow"><xsl:apply-templates/></TR>
  </xsl:template>
  
  <xsl:template match="empty-cell">
	  <TD style="background-color:black"><xsl:apply-templates/></TD>
  </xsl:template>

  <xsl:template match="row[1]/column-header-cell">
	  <TH><SPAN style="text-decoration:underline"><xsl:apply-templates/></SPAN></TH>
  </xsl:template>

  <xsl:template match="cell[1]">
	  <TH><SPAN style="color:red;text-decoration:underline"><xsl:apply-templates/></SPAN></TH>
  </xsl:template>
  
</xsl:stylesheet>