<?xml version="1.0"?> 

<!-- stylesheet for testing xsl:for-each -->
<xsl:stylesheet xmlns:xsl="http://www.w3.org/XSL/Transform/1.0">
  <xsl:import href="tei_highlights_to_html.xsl"/>
  <xsl:import href="tei_tables_to_html.xsl"/>
  <xsl:include href="tei_lists_to_html.xsl"/>
  <xsl:include href="tei_header_to_html.xsl"/>

  <xsl:template match="table">
    <H1>Basic test for xsl:for-each (also position()=1 and not(position()=1))</H1>
    <P>Should see a table with row headers in gray, the upper left cell in black, 
    the first column header in blue type, and the rest of the column header text 
    in red type. The rest of the cells should be 
    in green type.</P>
	  <TABLE>
		<xsl:for-each select="row[1]">
			<TR style="background-color:gray">
				<xsl:for-each select="empty-cell">
					<TD style="background-color:black"><xsl:apply-templates/></TD>
				</xsl:for-each>
				<xsl:for-each select="column-header-cell[1]">
					<TD style="color:blue"><xsl:apply-templates/></TD>
				</xsl:for-each>
				<xsl:for-each select="column-header-cell[not(position()=1)]">
					<TD style="color:red"><xsl:apply-templates/></TD>
				</xsl:for-each>
			</TR>
		</xsl:for-each>
		<xsl:for-each select="row[not(position()=1)]">
			<TR style="color:green">
				<xsl:for-each select="cell">
					  <TD><xsl:apply-templates/></TD>
				</xsl:for-each>
			</TR>
		</xsl:for-each>
	  </TABLE>
  </xsl:template>
  
</xsl:stylesheet>