<?xml version="1.0"?> 

<!-- stylesheet for lightweight types -->
<xsl:stylesheet xmlns:xsl="http://www.w3.org/XSL/Transform/1.0">
  <xsl:include href="html_output_default.xsl"/>

  <!-- <emph> marks words or phrases which are stressed or emphasized 
       for linguistic or rhetorical effect. --> 
  <xsl:template match="emph">
    <EM><xsl:apply-templates/></EM>
  </xsl:template>

  <!-- <q> contains a quotation or apparent quotation. -->
  <xsl:template match="q">
    <Q><xsl:apply-templates/></Q>
  </xsl:template>
 
  <!-- <soCalled> ... --> 
  <xsl:template match="soCalled">
    <I><xsl:apply-templates/></I>
  </xsl:template>

  <!-- <term> contains a single-word, multi-word or symbolic 
       designation which is regarded as a technical term. --> 
  <xsl:template match="term">
    <DFN><xsl:apply-templates/></DFN>
  </xsl:template>

  <xsl:template match="note">
    <SPAN border="1px solid black" color="teal">[NOTE: <xsl:apply-templates/>]</SPAN>
  </xsl:template>

  <xsl:template match="title">
    <SPAN text-decoration="underline"><xsl:apply-templates/></SPAN>
  </xsl:template>

  <xsl:template match="p">
    <P><xsl:apply-templates/></P>
  </xsl:template>
 
</xsl:stylesheet>