<?xml version="1.0"?> 

<xsl:stylesheet xmlns:xsl="http://www.w3.org/XSL/Transform/1.0" indent-result="yes">

  <xsl:key name="titles" match="div" use="title"/>
  <xsl:key name="id" match="*[@id]" use="@id"/>

  <xsl:template match="doc">
      <H1>Test for xsl:key, and keyref().</H1>
      <P>Reference numbers should match the titles, links should work.</P>
      <xsl:for-each select="div">
        <HR/>
        <H1 id="{generate-id(.)}">
        <xsl:number level="multi" match="div" format="1.1. "/>
        <xsl:value-of select="title"/></H1>
        <xsl:apply-templates/>
      </xsl:for-each>
  </xsl:template>
  
  <xsl:template match="p">
    <P><xsl:apply-templates/></P>
  </xsl:template>

  <xsl:template match="divref">
    <A href="#{generate-id(keyref('titles', .))}">
      <xsl:for-each select="keyref('titles', .)">
         <xsl:number level="multi" match="div" format="1.1. "/>
      </xsl:for-each>
      <xsl:value-of select="."/>
    </A>
  </xsl:template> 

  <xsl:template match="keydivref">
    <A href="#{generate-id(keyref('id', .))}">
      <xsl:for-each select="keyref('id', .)">
         <xsl:number level="multi" match="div" format="1.1. "/>
      </xsl:for-each>
      <xsl:value-of select="."/>
    </A>
  </xsl:template>
</xsl:stylesheet>
