<?xml version="1.0"?> 

<xsl:stylesheet xmlns:xsl="http://www.w3.org/XSL/Transform/1.0" indent-result="yes">

  <xsl:key name="titles" match="div" use="title"/>

  <xsl:template match="doc">
      <H1>Test for xsl:key pattern matching.</H1>
      <HR/>
      <P>Should say "template 1->Intro Section.": </P>
      <P><xsl:apply-templates select="key('titles', 'Introduction')"/></P>
      <HR/>
      <P>Should say "template 2->SS Section.": </P>
      <P><xsl:apply-templates select="key('titles', 'Stylesheet Structure')/p"/></P>
      <HR/>
      <P>Should say "template 3->Exp Section.": </P>
      <P><xsl:apply-templates select="key('titles', 'Expressions')/p"/></P>
      <HR/>
      <P>Should say "template 4->Pat Section.": </P>
      <P><xsl:apply-templates select="key('titles', 'Patterns')/p"/></P>
  </xsl:template>
  
  <xsl:template match="key('titles', 'Introduction')">
    template 1-><xsl:value-of select="p"/>
  </xsl:template>
    
  <xsl:template match="key('titles', 'Stylesheet Structure')/p">
    template 2-><xsl:value-of select="."/>
  </xsl:template>

  <xsl:template match="doc/key('titles', 'Expressions')/p">
    template 3-><xsl:value-of select="."/>
  </xsl:template>

  <xsl:template match="/doc/key('titles', 'Patterns')/p">
    template 4-><xsl:value-of select="."/>
  </xsl:template>
    
</xsl:stylesheet>