<?xml version="1.0"?> 

<xsl:stylesheet xmlns:xsl="http://www.w3.org/XSL/Transform/1.0">

  <xsl:template match="doc">
    <HTML>
      <H1>Test for number().</H1>
      <P>Warning about not-a-reference variable is normal.</P>
      <HR/>
      <P>Should say "1" (node-set to number): <xsl:value-of select="number(n1)"/></P>
      <P>Should say "" (empty node-set to number): <xsl:value-of select="number(foo)"/></P>
      <P>Should say "2" (number to number): <xsl:value-of select="number(2)"/></P>
      <P>Should say "3"  (string to number): <xsl:value-of select="number('3')"/></P>
      <P>Should say "" (empty string to number): <xsl:value-of select="number('')"/></P>
      <P>Should say "" (alpha string to number): <xsl:value-of select="number('abc')"/></P>
      <xsl:variable name="ResultTreeFragTest">
        <xsl:value-of select="n4"/>
      </xsl:variable>
      <xsl:variable name="emptyResultTreeFragTest">
        <xsl:value-of select="foo"/>
      </xsl:variable>
      <P>Should say "4" (result-tree-fragment to number): 
        <xsl:value-of select="number($ResultTreeFragTest)"/></P>
      <P>Should say "" (empty result-tree-fragment to number): 
        <xsl:value-of select="number($emptyResultTreeFragTest)"/></P>
      <P>Should say "" (non-existent variable to number): 
        <xsl:value-of select="number($not-a-reference)"/></P>
    </HTML>
  </xsl:template>
 
</xsl:stylesheet>
