/* $Id: ColumnIterator.java,v 2.1.2.1 1999/07/09 23:02:46 borg Exp $ */
/* Copyright  1999 George Reese, All Rights Reserved */
package com.imaginary.sql.msql;

import java.sql.SQLException;
import com.sun.java.util.collections.Iterator;
import com.sun.java.util.collections.UnsupportedOperationException;

/**
 * Enables an application to run through a rows columns using the
 * <CODE>Iterator</CODE> interface.
 * <BR>
 * Last modified $Date: 1999/07/09 23:02:46 $
 * @version $Revision: 2.1.2.1 $
 * @author George Reese (borg@imaginary.com)
 * @see com.sun.java.util.collections.Iterator
 */
public class ColumnIterator implements Iterator {
    private int       currentColumn = -1;
    private ParsedRow row           = null;

    public ColumnIterator(ParsedRow pr) {
	super();
	row = pr;
    }
    
    public boolean hasNext() {
	try {
	    return row.hasColumn(currentColumn+1);
	}
	catch( SQLException e ) {
	    return false;
	}
    }
    
    public Object next() {
	currentColumn++;
	try {
	    return row.get(currentColumn);
	}
	catch( SQLException e ) {
	    return null;
	}
    }

    public void remove() {
	throw new UnsupportedOperationException();
    }
    
}
