#
# Revision: 35 1.1 build/try.ksh, build, xml4j2, xml4j2_0_13 
#

#
# This file just prints out the environment variables defined in the
# file setupEnvVars.ksh
#
# This script tests whether the build environment is setup correctly
# or not. You should be able to run this script from any directory.
#


. setupEnvVars.ksh




errFlg=0


if test ! -n "$BUILDJDKDIR"
then
    echo "Build Error: Environment variable BUILDJDKDIR is not set."
    errFlg=1
else
    echo "BUILDJDKDIR=$BUILDJDKDIR  is used to build XML4J"
fi


if test ! -n "$JDK12BIN"
then
    echo "Build Error: Environment variable JDK12BIN is not set."
    errFlg=1
else
    echo "JDK12BIN=$JDK12BIN"
fi


if test ! -n "$SWINGJAR"
then
    echo "Build Error: Environment variable SWINGJAR is not set."
    errFlg=1
else
    echo "SWINGJAR=$SWINGJAR"
fi


if test ! -n "$CLASSPATH"
then
    echo "Build Error: Environment variable CLASSPATH is not set."
    errFlg=1
else
    echo "CLASSPATH=$CLASSPATH"
fi


if test ! -n "$JAVACFLAGS"
then
    echo "Build Error: Environment variable JAVACFLAGS is not set."
    errFlg=1
else
    echo "JAVACFLAGS=$JAVACFLAGS"
fi


if test ! -n "$XML4JVERSION"
then
    echo "Build Error: Environment variable XML4JVERSION is not set."
    errFlg=1
else
    echo "XML4JVERSION=$XML4JVERSION"
fi


if test ! -n "$ZipFile"
then
    echo "Build Error: Environment variable ZipFile is not set."
    errFlg=1
else
    echo "ZipFile=$ZipFile"
fi


if test ! -n "$TarFile"
then
    echo "Build Error: Environment variable TarFile is not set."
    errFlg=1
else
    echo "TarFile=$TarFile"
fi


if test ! -n "$JarFile"
then
    echo "Build Error: Environment variable JarFile is not set."
    errFlg=1
else
    echo "JarFile=$JarFile"
fi


if test ! -n "$XML4JCLASSFILESDIR"
then
    echo "Build Error: Environment variable XML4JCLASSFILESDIR is not set."
    errFlg=1
else
    echo "XML4JCLASSFILESDIR=$XML4JCLASSFILESDIR"
fi


if test ! -n "$XML4JAPIDOCDIR"
then
    echo "Build Error: Environment variable XML4JAPIDOCDIR is not set."
    errFlg=1
else
    echo "XML4JAPIDOCDIR=$XML4JAPIDOCDIR"
fi


if test ! -n "$XML4JSHIPROOTDIR"
then
    echo "Build Error: Environment variable XML4JSHIPROOTDIR is not set."
    errFlg=1
else
    echo "XML4JSHIPROOTDIR=$XML4JSHIPROOTDIR"
fi


if test ! -n "$DOCSRCDIR"
then
    echo "Build Error: Environment variable DOCSRCDIR is not set."
    errFlg=1
else
    echo "DOCSRCDIR=$DOCSRCDIR"
fi


if test ! -n "$SRCDIR"
then
    echo "Build Error: Environment variable SRCDIR is not set."
    errFlg=1
else
    echo "SRCDIR=$SRCDIR"
fi


if test ! -n "$SCRIPTSSRCDIR"
then
    echo "Build Error: Environment variable SCRIPTSSRCDIR is not set."
    errFlg=1
else
    echo "SCRIPTSSRCDIR=$SCRIPTSSRCDIR"
fi


if test ! -n "$TestsDir"
then
    echo "Build Error: Environment variable TestsDir is not set."
    errFlg=1
else
    echo "TestsDir=$TestsDir"
fi


if test ! -n "$TestResultsFile"
then
    echo "Build Error: Environment variable TestResultsFile is not set."
    errFlg=1
else
    echo "TestResultsFile=$TestResultsFile"
fi


if test $errFlg -eq 1
then
    echo "Aborting..."
    exit
else
    echo ""
fi


