/*
 * (C) Copyright IBM Corp. 1998,1999  All rights reserved.
 *
 * US Government Users Restricted Rights Use, duplication or
 * disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 *
 * The program is provided "as is" without any warranty express or
 * implied, including the warranty of non-infringement and the implied
 * warranties of merchantibility and fitness for a particular purpose.
 * IBM will not be liable for any damages suffered by you as a result
 * of using the Program. In no event will IBM be liable for any
 * special, indirect or consequential damages or lost profits even if
 * IBM has been advised of the possibility of their occurrence. IBM
 * will not be liable for any third party claims against you.
 */

package com.ibm.xml.framework;

/**
 * Parameter object for the ElementDeclPool.getContentSpecNode() method
 *
 * @version Revision: 58 1.5 src/com/ibm/xml/framework/ContentSpecNode.java, parser, xml4j2, xml4j2_0_13 
 */
public final class ContentSpecNode {
    //
    // nodeType
    //
    // Note: The #PCDATA leaf in a MIXED content spec is indicated by an fNodeType
    //       of NODE_LEAF and an fNodeValue of -1.
    //
    public static final int
        NODE_LEAF           = 0,            // Name or #PCDATA (-1)
        NODE_ZERO_OR_ONE    = 1,            // '?'
        NODE_ZERO_OR_MORE   = 2,            // '*'
        NODE_ONE_OR_MORE    = 3,            // '+'
        NODE_CHOICE         = 4,            // '|'
        NODE_SEQ            = 5;            // ','
    //
    // Public instance variables - filled in on each call to getContentSpecNode().
    //
    public int type;                        // node type (see above)
    public int value;                       // leaf index, single child for unary ops, left child for binary ops.
    public int otherValue;                  // right child for binary ops
}
