/*
 * (C) Copyright IBM Corp. 1998,1999  All rights reserved.
 *
 * US Government Users Restricted Rights Use, duplication or
 * disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 *
 * The program is provided "as is" without any warranty express or
 * implied, including the warranty of non-infringement and the implied
 * warranties of merchantibility and fitness for a particular purpose.
 * IBM will not be liable for any damages suffered by you as a result
 * of using the Program. In no event will IBM be liable for any
 * special, indirect or consequential damages or lost profits even if
 * IBM has been advised of the possibility of their occurrence. IBM
 * will not be liable for any third party claims against you.
 */

package com.ibm.xml.framework;

/**
 * Parameter object for the ElementDeclPool.addElementDecl() method
 *
 * @version Revision: 43 1.5 src/com/ibm/xml/framework/ElementDecl.java, parser, xml4j2, xml4j2_0_13 
 */
public final class ElementDecl {
    //
    // contentSpecType
    //
    public static final int
        CONTENTSPEC_UNKNOWN     = 0,
        CONTENTSPEC_EMPTY       = 1,
        CONTENTSPEC_ANY         = 2,
        CONTENTSPEC_MIXED       = 3,
        CONTENTSPEC_CHILDREN    = 4;
    //
    // Public instance variables - fill these in for each call to addElementDecl().
    //
    public int elementName;        // element name
    public int contentSpecType;    // EMPTY, ANY, MIXED, CHILDREN
    public int contentSpec;        // root node of MIXED or CHILDREN content spec
};
