/*
 * (C) Copyright IBM Corp. 1998,1999  All rights reserved.
 *
 * US Government Users Restricted Rights Use, duplication or
 * disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 *
 * The program is provided "as is" without any warranty express or
 * implied, including the warranty of non-infringement and the implied
 * warranties of merchantibility and fitness for a particular purpose.
 * IBM will not be liable for any damages suffered by you as a result
 * of using the Program. In no event will IBM be liable for any
 * special, indirect or consequential damages or lost profits even if
 * IBM has been advised of the possibility of their occurrence. IBM
 * will not be liable for any third party claims against you.
 */

package com.ibm.xml.framework;

/**
 *
 * @version Revision: 53 1.7 src/com/ibm/xml/framework/XMLDocumentTypeHandler.java, parser, xml4j2, xml4j2_0_13 
 */
public interface XMLDocumentTypeHandler {
    //
    // XMLDocumentTypeHandler interface
    //

    /**
     *  This function will be called when a &lt;!DOCTYPE...&gt; declaration is
     *  encountered.
     */
    public void doctypeDecl(int rootElementNameIndex) throws Exception ;

    /**
     *  This function will be called at the start of the "internal subset" of a 
     *  doctype declaration.
     */
    public void startInternalSubset() throws Exception ;

    /**
     *  This function will be called at the end of the "internal subset" of a 
     *  doctype declaration.
     */
    public void endInternalSubset() throws Exception ;

    /**
     *  This function will be called at the start of the "external subset" of a 
     *  doctype declaration.
     */
    public void startExternalSubset(int publicIdStringIndex, int systemIdStringIndex) throws Exception ;
    
    /**
     *  This function will be called at the end of the "external subset" of a 
     *  doctype declaration.
     */
    public void endExternalSubset() throws Exception ;
 
    //
    // <!ELEMENT Name contentspec>
    //
    public void elementDecl(int elementIndex) throws Exception;
    //
    // <!ATTLIST Name AttDef>
    //
    public void attlistDecl(int elementIndex, int attDefIndex) throws Exception;
    //
    // <!ENTITY Name EntityValue>               (internal)
    // <!ENTITY Name ExternalID>                (external)
    // <!ENTITY Name ExternalID NDataDecl>      (unparsed)
    //
    public void internalEntityDecl(int entityIndex) throws Exception;
    public void externalEntityDecl(int entityIndex) throws Exception;
    public void unparsedEntityDecl(int entityIndex) throws Exception;
    //
    // <!NOTATION Name ExternalId>
    //
    public void notationDecl(int notationIndex) throws Exception;
}
