/*
 * (C) Copyright IBM Corp. 1998,1999  All rights reserved.
 *
 * US Government Users Restricted Rights Use, duplication or
 * disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 *
 * The program is provided "as is" without any warranty express or
 * implied, including the warranty of non-infringement and the implied
 * warranties of merchantibility and fitness for a particular purpose.
 * IBM will not be liable for any damages suffered by you as a result
 * of using the Program. In no event will IBM be liable for any
 * special, indirect or consequential damages or lost profits even if
 * IBM has been advised of the possibility of their occurrence. IBM
 * will not be liable for any third party claims against you.
 */

package com.ibm.xml.internal;

import com.ibm.xml.framework.XMLErrorHandler;

/**
 *
 * @version Revision: 82 1.3 src/com/ibm/xml/internal/CMException.java, parser, xml4j2, xml4j2_0_13 
 */
class CMException extends Exception
{
    // -------------------------------------------------------------------
    //  Constructors
    // -------------------------------------------------------------------
    CMException(int errCode)
    {
        fErrorCode = errCode;
    }

    // -------------------------------------------------------------------
    //  Package methods
    // -------------------------------------------------------------------
    void send(XMLErrorHandler errHandler) throws Exception
    {
        errHandler.error(fErrorCode);
    }


    // -------------------------------------------------------------------
    //  Private constants
    // -------------------------------------------------------------------
    final int       fUnused = -1000;


    // -------------------------------------------------------------------
    //  Private data members
    //
    //  fErrorCode
    //      The id from ErrorCode for the error being reported.
    // -------------------------------------------------------------------
    private int     fErrorCode;
};
