/*
 * (C) Copyright IBM Corp. 1997-1999  All rights reserved.
 *
 * US Government Users Restricted Rights Use, duplication or
 * disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 *
 * The program is provided "as is" without any warranty express or
 * implied, including the warranty of non-infringement and the implied
 * warranties of merchantibility and fitness for a particular purpose.
 * IBM will not be liable for any damages suffered by you as a result
 * of using the Program. In no event will IBM be liable for any
 * special, indirect or consequential damages or lost profits even if
 * IBM has been advised of the possibility of their occurrence. IBM
 * will not be liable for any third party claims against you.
 */

package com.ibm.xml.parser;

/**
 * XML4J administrative class to keep track of the version number of
 * the release.
 *
 * @version Revision: 10 1.7 src/com/ibm/xml/parser/Version.java, parser, xml4j2, xml4j2_0_13 
 */

public class Version {
    /**
     * Version String like <CODE>"<B>XML4</B>i v.r[.dd| <B>D</B>nn]"</CODE>.
     * Semantics of the version string are explained in the FAQ.
     */
    public static String S_VERSION = "1.1.16";

    /**
     * Major version number.
     */
    public static int MAJOR = 1;

    /**
     * Minor version number.
     */
    public static int MINOR = 1;

    /**
     * SubMinor version number.
     */
    public static int SUBMINOR = 16;
}
