#
# (C) Copyright IBM Corp. 1998  All rights reserved.
#
# US Government Users Restricted Rights Use, duplication or
# disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
#
# The program is provided "as is" without any warranty express or
# implied, including the warranty of non-infringement and the implied
# warranties of merchantibility and fitness for a particular purpose.
# IBM will not be liable for any damages suffered by you as a result
# of using the Program. In no event will IBM be liable for any
# special, indirect or consequential damages or lost profits even if
# IBM has been advised of the possibility of their occurrence. IBM
# will not be liable for any third party claims against you.
#
#
# Revision: 32 1.5 src/com/ibm/xml/parser/makeit.ksh, build, xml4j2, xml4j2_0_13 
#

#
# Make script for com/ibm/xml/parser directory.
#


. setupEnvVars.ksh


THISDIR=com/ibm/xml/parser
THISCLASSDIR=$XML4JCLASSFILESDIR/$THISDIR
SRCDIR=.

SRCFILES="`ls -1 *.java`"
case $# in
    0)  target=all;;
    *)  target=$1;;
esac

case $target in 
    all)          javac $JAVACFLAGS $SRCFILES;
                  mesg="Finished compiling all files in $THISDIR.";;
    veryclean)    rm -f $THISCLASSDIR/*.class;
                  mesg="Finished cleanup in $THISDIR.";;
    *)            echo "Target '$target' not recognized.";
                  mesg="Finished processing '$target' in $THISDIR.";;
esac

for i in util
do
    if test -d $i
    then
        echo Building $target in directory $THISDIR/$i.
        $SH -c "cd $i; ./makeit.ksh $target"
    else
        echo Skipping directory $THISDIR/$i.
    fi
done

echo $mesg
exit


#
# XMLChar.java is created from XMLChar.java.h and XMLChar.java.t and XMLCharGen.
# The body of XMLChar.java is generated by running the java program XMLCharGen.
# 
# We have already generated the file XMLChar.java. It checked into the
# source control repository. It is also included in the makefile.
#
# The following rule on how to generate the file XMLChar.java is mentioned just
# incase the file has to be created from scratch again.
#
# FOR NOW WE SHALL COMMENT THIS FILE GENERATION RULE.
#

# XMLChar.class: XMLChar.java.h XMLChar.java.t XMLChar.java.body
# 	cat XMLChar.java.h XMLChar.java.body XMLChar.java.t > XMLChar.java
# 	javac $(JAVACFLAGS) XMLChar.java

# XMLChar.java.body: XMLCharGen.class
# 	$(JAVA) com.ibm.xml.parser.XMLCharGen range > XMLChar.java.body
