/*
 * (C) Copyright IBM Corp. 1997-1999  All rights reserved.
 *
 * US Government Users Restricted Rights Use, duplication or
 * disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 *
 * The program is provided "as is" without any warranty express or
 * implied, including the warranty of non-infringement and the implied
 * warranties of merchantibility and fitness for a particular purpose.
 * IBM will not be liable for any damages suffered by you as a result
 * of using the Program. In no event will IBM be liable for any
 * special, indirect or consequential damages or lost profits even if
 * IBM has been advised of the possibility of their occurrence. IBM
 * will not be liable for any third party claims against you.
 */

package com.ibm.xml.xpointer;

/**
 * XML4J XPointer exception which signals that the XPointer parser has detected an internal error
 * of some sort.  Usually, this means that the parser encountered a severe syntax error
 * in the XPointer being parsed.
 *
 * @version Revision: 24 1.5 src/com/ibm/xml/xpointer/XPointerParseException.java, parser, xml4j2, xml4j2_0_13 
 * @author TAMURA Kent &lt;kent@trl.ibm.co.jp&gt;
 */

public class XPointerParseException extends Exception {

    static final long serialVersionUID = 4944492811721482978L;
    /**
     * Constructor for exception with detail message.
     * @param msg       The detail message for the exception.
     */
    public XPointerParseException(String msg) {
        super(msg);
    }

    /**
     * Constructor for exception with no detail message.
     */
    public XPointerParseException() {
        super();
    }
}
