#
# (C) Copyright IBM Corp. 1998  All rights reserved.
#
# US Government Users Restricted Rights Use, duplication or
# disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
#
# The program is provided "as is" without any warranty express or
# implied, including the warranty of non-infringement and the implied
# warranties of merchantibility and fitness for a particular purpose.
# IBM will not be liable for any damages suffered by you as a result
# of using the Program. In no event will IBM be liable for any
# special, indirect or consequential damages or lost profits even if
# IBM has been advised of the possibility of their occurrence. IBM
# will not be liable for any third party claims against you.
#
#
# Revision: 40 1.4 src/makeit.ksh, build, xml4j2, xml4j2_0_13 
#

#
# Make script for ../src directory.
#


. setupEnvVars.ksh



THISDIR=
THISCLASSDIR=$XML4JCLASSFILESDIR/$THISDIR
SRCDIR=.


SRCFILES=

case $# in
    0)  target=all;;
    *)  target=$1;;
esac

case $target in 
    all)
#                 Create the $XML4JCLASSFILESDIR, if necessary.
                  if test ! -d $XML4JCLASSFILESDIR
                  then
                      mkdir $XML4JCLASSFILESDIR;
                  fi
                  echo "Compiling all files in src root directory...";
                  mesg="Finished compiling all files in src root directory.";;
    veryclean)    echo "Cleaning up in src root directory...";
                  mesg="Finished cleanup in src root directory.";;
    *)            echo "Target '$target' not recognized.";
                  mesg="Finished processing '$target' in src root directory.";;
esac

for i in org/w3c/dom org/xml/sax com/ibm
do
    if test -d $i
    then
        echo Building $target in directory $THISDIR/$i.
        $SH -c "cd $i; ./makeit.ksh $target"
    else
        echo Skipping directory $THISDIR/$i.
    fi
done

echo $mesg
exit
